/*==============================================================*/
/* Database name:  DATABASE_1                                   */
/* DBMS name:      ORACLE Version 11g                           */
/* Created on:     16/05/2012 20:39:10                          */
/*==============================================================*/


alter table CIUTAT
   drop constraint FK_PROVINCIA_CIUTAT;

alter table DIA
   drop constraint "FK_Mes_Dia";

alter table DIA
   drop constraint FK_REF_SETMANA_DIA;

alter table MES
   drop constraint FK_ANY_MES;

alter table OFERTA
   drop constraint FK_CIUTAT_OFERTA;

alter table OFERTA
   drop constraint "FK_Data_Alta_Oferta";

alter table OFERTA
   drop constraint FK_OFERTA_REF_DATA__DIA;

alter table OFERTA
   drop constraint FK_EMPRESA_OFERTA;

alter table OFERTA
   drop constraint FK_REF_JORNADA_OFERTA;

alter table OFERTA
   drop constraint FK_REF_ROL_OFERTA;

alter table OFERTA
   drop constraint FK_SUB_SECTOR_OFERTA;

alter table OFERTA
   drop constraint FK_TIPUS_CONTRACTE_OFERTA;

alter table PROVINCIA
   drop constraint FK_PROVINCI_REF_PAIS__PAIS;

alter table SETMANA
   drop constraint FK_ANY_SETMANA;

alter table SUB_SECTOR
   drop constraint FK_SUB_SECT_REF_SECTO_SECTOR;

drop table CIUTAT cascade constraints;

drop table CONTROL_DATES cascade constraints;

drop table CONTROL_ERRORS cascade constraints;

drop table DIA cascade constraints;

drop table EMPRESA cascade constraints;

drop table MES cascade constraints;

drop table MESTRE_ROLS cascade constraints;

drop table NUMANY cascade constraints;

drop table OFERTA cascade constraints;

drop table PAIS cascade constraints;

drop table PROVINCIA cascade constraints;

drop table SECTOR cascade constraints;

drop table SETMANA cascade constraints;

drop table SUB_SECTOR cascade constraints;

drop table TAULA_LOG cascade constraints;

drop table TIPUS_CONTRACTE cascade constraints;

drop table TIPUS_JORNADA cascade constraints;

drop sequence SEQ_LOG;

create sequence SEQ_LOG
increment by 1
start with 1
 nomaxvalue;

/*==============================================================*/
/* Table: CIUTAT                                                */
/*==============================================================*/
create table CIUTAT 
(
   ID_PROVINCIA_CIUTAT  NUMBER               not null,
   ID_CIUTAT            NUMBER               not null,
   ID_PAIS_PROVINCIA    NUMBER,
   DESC_CIUTAT          VARCHAR2(50 CHAR)    not null,
   constraint PK_CIUTAT primary key (ID_PROVINCIA_CIUTAT, ID_CIUTAT)
);

/*==============================================================*/
/* Table: CONTROL_DATES                                         */
/*==============================================================*/
create table CONTROL_DATES 
(
   DATA_INICIAL         DATE                 not null,
   DATA_FINAL           DATE                 not null,
   constraint PK_CONTROL_DATES primary key (DATA_INICIAL, DATA_FINAL)
);

/*==============================================================*/
/* Table: CONTROL_ERRORS                                        */
/*==============================================================*/
create table CONTROL_ERRORS 
(
   NOM_TAULA            VARCHAR2(200 CHAR)   not null,
   NOMBRE_ERRORS        NUMBER               not null,
   constraint PK_CONTROL_ERRORS primary key (NOM_TAULA)
);

/*==============================================================*/
/* Table: DIA                                                   */
/*==============================================================*/
create table DIA 
(
   DIA                  DATE                 not null,
   NUMANY               NUMBER,
   NUM_MES              NUMBER,
   NUM_SETMANA          NUMBER               not null,
   DESC_DIA             VARCHAR2(50 CHAR)    not null,
   DIA_SETMANA          NUMBER               not null,
   constraint PK_DIA primary key (DIA)
);

/*==============================================================*/
/* Table: EMPRESA                                               */
/*==============================================================*/
create table EMPRESA 
(
   ID_EMPRESA           NUMBER               not null,
   NOM_EMPRESA          VARCHAR(50),
   CIF_EMPRESA          VARCHAR2(9 CHAR)     not null,
   DATA_ALTA            DATE                 not null,
   DATA_BAIXA           DATE,
   NOMBRE_TREBALLADORS  NUMBER               not null,
   ADRECA_WEB_EMPRESA   VARCHAR2(200 CHAR),
   constraint PK_EMPRESA primary key (ID_EMPRESA),
   constraint AK_AK_CORREU_ELECTRON_EMPRESA unique (CIF_EMPRESA)
);

/*==============================================================*/
/* Table: MES                                                   */
/*==============================================================*/
create table MES 
(
   NUMANY               NUMBER               not null,
   NUM_MES              NUMBER               not null,
   DESC_MES             VARCHAR2(50 CHAR)    not null,
   constraint PK_MES primary key (NUMANY, NUM_MES)
);

/*==============================================================*/
/* Table: MESTRE_ROLS                                           */
/*==============================================================*/
create table MESTRE_ROLS 
(
   ID_ROL               NUMBER               not null,
   DESC_ROL             VARCHAR2(50 CHAR)    not null,
   constraint PK_MESTRE_ROLS primary key (ID_ROL)
);

/*==============================================================*/
/* Table: NUMANY                                                */
/*==============================================================*/
create table NUMANY 
(
   NUMANY               NUMBER               not null,
   DESC_ANY             VARCHAR2(50 CHAR)    not null,
   constraint PK_NUMANY primary key (NUMANY)
);

/*==============================================================*/
/* Table: OFERTA                                                */
/*==============================================================*/
create table OFERTA 
(
   ID_EMPRESA_OFERTA    NUMBER               not null,
   ID_OFERTA            NUMBER               not null,
   ID_SECTOR            NUMBER,
   DATA_ALTA_OFERTA     DATE                 not null,
   NOMBRE_VACANTS_OFERTA NUMBER               not null,
   SALARI_MINIM_OFERTA  VARCHAR2(200 CHAR),
   SALARI_MAXIM_OFERTA  NUMBER,
   TIPUS_CONTRACTE_OFERTA NUMBER               not null,
   TIPUS_JORNADA_OFERTA NUMBER               not null,
   SUB_SECTOR_EMPRESA   NUMBER               not null,
   CIUTAT_TREBALL_OFERTA NUMBER               not null,
   ROL_CANDIDAT_OFERTA  NUMBER               not null,
   DATA_LIMIT           DATE                 not null,
   DESCRIPCIO_CURTA_OFERTA VARCHAR2(15 CHAR)    not null,
   ID_PROVINCIA_CIUTAT  NUMBER               not null,
   CANDIDAT_TROBAT      NUMBER               not null,
   COMPTADOR            NUMBER               not null,
   DIES_SELECCIO        NUMBER               not null,
   EXPERIENCIES_ACCEPTAT NUMBER               not null,
   CANDIDATS_TOTALS     NUMBER               not null,
   CANDIDATURES_ENVIADES NUMBER               not null,
   CANDIDATURES_REBUTJADES NUMBER               not null,
   CANDIDATURES_ACCEPTADES NUMBER               not null,
   CANDIDATURES_EN_PROCES NUMBER               not null,
   constraint PK_OFERTA primary key (ID_EMPRESA_OFERTA, ID_OFERTA)
);

/*==============================================================*/
/* Table: PAIS                                                  */
/*==============================================================*/
create table PAIS 
(
   ID_PAIS              NUMBER               not null,
   DESC_PAIS            VARCHAR2(50 CHAR)    not null,
   constraint PK_PAIS primary key (ID_PAIS)
);

/*==============================================================*/
/* Table: PROVINCIA                                             */
/*==============================================================*/
create table PROVINCIA 
(
   ID_PAIS_PROVINCIA    NUMBER               not null,
   ID_PROVINCIA         NUMBER               not null,
   DESC_PROVINCIA       VARCHAR2(50 CHAR)    not null,
   constraint PK_PROVINCIA primary key (ID_PAIS_PROVINCIA, ID_PROVINCIA)
);

/*==============================================================*/
/* Table: SECTOR                                                */
/*==============================================================*/
create table SECTOR 
(
   ID_SECTOR            NUMBER               not null,
   DESC_SECTOR          VARCHAR2(50 CHAR)    not null,
   constraint PK_SECTOR primary key (ID_SECTOR)
);

/*==============================================================*/
/* Table: SETMANA                                               */
/*==============================================================*/
create table SETMANA 
(
   "ANY"                NUMBER               not null,
   NUM_SETMANA          NUMBER               not null,
   DESC_SETMANA         VARCHAR2(50 CHAR)    not null,
   constraint PK_SETMANA primary key ("ANY", NUM_SETMANA)
);

/*==============================================================*/
/* Table: SUB_SECTOR                                            */
/*==============================================================*/
create table SUB_SECTOR 
(
   ID_SECTOR            NUMBER               not null,
   ID_SUB_SECTOR        NUMBER               not null,
   DESC_SUB_SECTOR      VARCHAR2(50 CHAR)    not null,
   constraint PK_SUB_SECTOR primary key (ID_SECTOR, ID_SUB_SECTOR)
);

/*==============================================================*/
/* Table: TAULA_LOG                                             */
/*==============================================================*/
create table TAULA_LOG 
(
   ID_LOG               NUMBER               not null,
   DATA_ALTA            DATE,
   DESCRIPCIO_PROBLEMA  VARCHAR2(500 CHAR),
   constraint PK_TAULA_LOG primary key (ID_LOG)
);

/*==============================================================*/
/* Table: TIPUS_CONTRACTE                                       */
/*==============================================================*/
create table TIPUS_CONTRACTE 
(
   M_CONTRACTE          NUMBER               not null,
   DESCRIPCIO_CONTRACTE VARCHAR2(50)         not null,
   constraint PK_TIPUS_CONTRACTE primary key (M_CONTRACTE)
);

/*==============================================================*/
/* Table: TIPUS_JORNADA                                         */
/*==============================================================*/
create table TIPUS_JORNADA 
(
   M_JORNADA            NUMBER               not null,
   DESCRIPCIO_JORNADA   VARCHAR2(50)         not null,
   constraint PK_TIPUS_JORNADA primary key (M_JORNADA)
);

alter table CIUTAT
   add constraint FK_PROVINCIA_CIUTAT foreign key (ID_PAIS_PROVINCIA, ID_PROVINCIA_CIUTAT)
      references PROVINCIA (ID_PAIS_PROVINCIA, ID_PROVINCIA);

alter table DIA
   add constraint "FK_Mes_Dia" foreign key (NUMANY, NUM_MES)
      references MES (NUMANY, NUM_MES);

alter table DIA
   add constraint FK_REF_SETMANA_DIA foreign key (NUMANY, NUM_SETMANA)
      references SETMANA ("ANY", NUM_SETMANA);

alter table MES
   add constraint FK_ANY_MES foreign key (NUMANY)
      references NUMANY (NUMANY);

alter table OFERTA
   add constraint FK_CIUTAT_OFERTA foreign key (ID_PROVINCIA_CIUTAT, CIUTAT_TREBALL_OFERTA)
      references CIUTAT (ID_PROVINCIA_CIUTAT, ID_CIUTAT);

alter table OFERTA
   add constraint "FK_Data_Alta_Oferta" foreign key (DATA_ALTA_OFERTA)
      references DIA (DIA);

alter table OFERTA
   add constraint FK_OFERTA_REF_DATA__DIA foreign key (DATA_LIMIT)
      references DIA (DIA);

alter table OFERTA
   add constraint FK_EMPRESA_OFERTA foreign key (ID_EMPRESA_OFERTA)
      references EMPRESA (ID_EMPRESA);

alter table OFERTA
   add constraint FK_REF_JORNADA_OFERTA foreign key (TIPUS_JORNADA_OFERTA)
      references TIPUS_JORNADA (M_JORNADA);

alter table OFERTA
   add constraint FK_REF_ROL_OFERTA foreign key (ROL_CANDIDAT_OFERTA)
      references MESTRE_ROLS (ID_ROL);

alter table OFERTA
   add constraint FK_SUB_SECTOR_OFERTA foreign key (ID_SECTOR, SUB_SECTOR_EMPRESA)
      references SUB_SECTOR (ID_SECTOR, ID_SUB_SECTOR);

alter table OFERTA
   add constraint FK_TIPUS_CONTRACTE_OFERTA foreign key (TIPUS_CONTRACTE_OFERTA)
      references TIPUS_CONTRACTE (M_CONTRACTE);

alter table PROVINCIA
   add constraint FK_PROVINCI_REF_PAIS__PAIS foreign key (ID_PAIS_PROVINCIA)
      references PAIS (ID_PAIS);

alter table SETMANA
   add constraint FK_ANY_SETMANA foreign key ("ANY")
      references NUMANY (NUMANY);

alter table SUB_SECTOR
   add constraint FK_SUB_SECT_REF_SECTO_SECTOR foreign key (ID_SECTOR)
      references SECTOR (ID_SECTOR);

