------------------------------------------
----------- VISTES -----------------------
------------------------------------------

--------------------------------------------------------
--  DDL for View V_CANDIDATURES_OFERTA
--------------------------------------------------------

  CREATE OR REPLACE FORCE VIEW "RELACIONAL"."V_CANDIDATURES_OFERTA" ("Id Empresa", "CIF Empresa", "Id CV", "Nom Candidat", "Primer Cognom", "Busca feina", "Data Inici Mes recent", "Rol") AS 
  select empresa.id_empresa "Id Empresa",
       empresa.cif_empresa "CIF Empresa",
       candidatura.id_cv_candidatura "Id CV",
       candidat.nom "Nom Candidat",
       candidat.cognom1 "Primer Cognom",
       candidat.esta_buscant "Busca feina",
       v_data_max_cv_exp.data_maxima "Data Inici Mes recent",
       mestre_rols.desc_rol "Rol"
from candidat,
     curriculum, 
     cv_experiencia,  
     candidatura,
     v_data_max_cv_exp,
     empresa,
     mestre_rols
where candidat.id_usuari=curriculum.id_candidat_cv and
      candidatura.id_candidat_cv=candidat.id_usuari and
      candidatura.id_candidat_cv=curriculum.id_cv and
      curriculum.id_candidat_cv=cv_experiencia.id_candidat_cv and
      curriculum.id_cv= cv_experiencia.id_cv and
      cv_experiencia.id_candidat_cv= v_data_max_cv_exp.id_candidat_cv and
      cv_experiencia.id_cv=v_data_max_cv_exp.id_cv and
      cv_experiencia.data_inici_exp = v_data_max_cv_exp.data_maxima and
      candidatura.id_empresa_oferta=empresa.id_empresa and
      mestre_rols.id_rol=cv_experiencia.rol_exp;
--------------------------------------------------------
--  DDL for View V_CERCA_OFERTES
--------------------------------------------------------

  CREATE OR REPLACE FORCE VIEW "RELACIONAL"."V_CERCA_OFERTES" ("Id Oferta", "Id Empresa", "Data Alta Oferta", "Desc Curta Oferta", "Rol a desenvolupar", "Sub sector Activitat", "Sector Activitat", "Salari Minim", "Salari Maxim", "Tipus de Jornada", "Tipus de Contracte", "Provincia Oferta") AS 
  SELECT id_oferta "Id Oferta",
    id_empresa_oferta "Id Empresa",
    o.data_alta "Data Alta Oferta",
    descripcio_curta_oferta "Desc Curta Oferta",
    r.desc_rol "Rol a desenvolupar",
    ss.desc_sub_sector "Sub sector Activitat",
    s.desc_sector "Sector Activitat",
    o.salari_minim_oferta "Salari Minim",
    o.salari_minim_oferta "Salari Maxim",
    tj.descripcio_jornada "Tipus de Jornada",
    tc.descripcio_contracte "Tipus de Contracte",
    provincia.desc_provincia "Provincia Oferta"
  FROM oferta o,
    mestre_rols r,
    sector s,
    sub_sector ss,
    empresa e,
    m_tipus_contracte tc,
    m_tipus_jornada tj,
    ciutat,
    provincia
  WHERE o.rol_candidat_oferta    =r.id_rol
  AND e.id_empresa               =o.id_empresa_oferta
  AND e.sub_sector_empresa       =ss.id_sub_sector
  AND e.sector_empresa           =s.id_sector
  AND s.id_sector                =ss.id_sector
  AND tc.m_contracte             =o.tipus_contracte_oferta
  AND tj.m_jornada               =o.tipus_jornada_oferta
  AND ciutat.id_provincia_ciutat = provincia.id_provincia
  AND ciutat.id_pais_provincia   =provincia.id_pais_provincia
  AND o.ciutat_treball_oferta    = ciutat.id_ciutat
  AND o.id_provincia_ciutat      =ciutat.id_provincia_ciutat;
--------------------------------------------------------
--  DDL for View V_DATA_MAX_CV_EXP
--------------------------------------------------------

  CREATE OR REPLACE FORCE VIEW "RELACIONAL"."V_DATA_MAX_CV_EXP" ("ID_CANDIDAT_CV", "ID_CV", "DATA_MAXIMA") AS 
  select id_candidat_cv, id_cv, max(data_inici_exp) data_maxima
       from cv_experiencia
       group by id_candidat_cv, id_cv;
--------------------------------------------------------
--  DDL for View V_DETALL_OFERTA
--------------------------------------------------------

  CREATE OR REPLACE FORCE VIEW "RELACIONAL"."V_DETALL_OFERTA" ("Id Oferta", "Id Empresa", "Data Alta Oferta", "Desc Curta Oferta", "Rol a desenvolupar", "Sub sector Activitat", "Sector Activitat", "Salari Minim", "Salari Maxim", "Tipus de Jornada", "Tipus de Contracte", "Provincia Oferta", "Ciutat Oferta", "Detall Oferta", "Requeriments Minims", "Requeriments desitjats") AS 
  SELECT id_oferta "Id Oferta",
    id_empresa_oferta "Id Empresa",
    o.data_alta "Data Alta Oferta",
    descripcio_curta_oferta "Desc Curta Oferta",
    r.desc_rol "Rol a desenvolupar",
    ss.desc_sub_sector "Sub sector Activitat",
    s.desc_sector "Sector Activitat",
    o.salari_minim_oferta "Salari Minim",
    o.salari_minim_oferta "Salari Maxim",
    tj.descripcio_jornada "Tipus de Jornada",
    tc.descripcio_contracte "Tipus de Contracte",
    provincia.desc_provincia "Provincia Oferta",
    ciutat.desc_ciutat "Ciutat Oferta",
    o.descripcio_oferta "Detall Oferta",
    o.requeriements_minims_oferta "Requeriments Minims",
    o.requeriments_desitjats_oferta "Requeriments desitjats"
  FROM oferta o,
    mestre_rols r,
    sector s,
    sub_sector ss,
    empresa e,
    m_tipus_contracte tc,
    m_tipus_jornada tj,
    ciutat,
    provincia
  WHERE o.rol_candidat_oferta    =r.id_rol
  AND e.id_empresa               =o.id_empresa_oferta
  AND e.sub_sector_empresa       =ss.id_sub_sector
  AND e.sector_empresa           =ss.id_sector
  AND s.id_sector                =ss.id_sector
  AND tc.m_contracte             =o.tipus_contracte_oferta
  AND tj.m_jornada               =o.tipus_jornada_oferta
  AND ciutat.id_provincia_ciutat = provincia.id_provincia
  AND ciutat.id_pais_provincia   =provincia.id_pais_provincia
  AND o.ciutat_treball_oferta    = ciutat.id_ciutat
  AND o.id_provincia_ciutat      =ciutat.id_provincia_ciutat;
--------------------------------------------------------
--  DDL for View V_ESTAT_CANDIDATURES
--------------------------------------------------------

  CREATE OR REPLACE FORCE VIEW "RELACIONAL"."V_ESTAT_CANDIDATURES" ("Candidat", "Data Alta Candidatura", "Empresa", "Descripcio Oferta", "Rol", "Estat Candidatura") AS 
  SELECT candidatura.id_candidat_cv "Candidat",
    candidatura.data_alta "Data Alta Candidatura",
    empresa.nom_empresa "Empresa",
    oferta.descripcio_curta_oferta "Descripcio Oferta",
    mestre_rols.desc_rol "Rol",
    m_estat_candidatura.descripcio_estat_candidatura "Estat Candidatura"
  FROM candidatura,
    empresa,
    oferta,
    mestre_rols,
    m_estat_candidatura
  WHERE candidatura.id_oferta_candidatura=oferta.id_oferta
  AND candidatura.id_empresa_oferta      =oferta.id_empresa_oferta
  AND candidatura.id_empresa_oferta      =empresa.id_empresa
  AND oferta.rol_candidat_oferta         =mestre_rols.id_rol
  AND candidatura.estat_candidatura      =m_estat_candidatura.m_estat_candidatura;
--------------------------------------------------------
--  DDL for View V_EXPERIENCIES_CV
--------------------------------------------------------

  CREATE OR REPLACE FORCE VIEW "RELACIONAL"."V_EXPERIENCIES_CV" ("Candidat", "CV", "Experiencia", "Sector", "Sub Sector", "Data Inici", "Data Fi", "Rol", "Persones a Carrec", "Descripcio") AS 
  select e.id_candidat_cv "Candidat",
       e.id_cv "CV",
       e.id_experiencia "Experiencia",
       sector.desc_sector "Sector",
       sub_sector.desc_sub_sector "Sub Sector",
       e.data_inici_exp "Data Inici",
       e.data_fi_exp "Data Fi",
       mestre_rols.desc_rol "Rol",
       e.persones_carrec "Persones a Carrec",
       e.descripcio_exp "Descripcio"
from cv_experiencia e,
     sector,
     sub_sector,
     mestre_rols
where e.rol_exp = mestre_rols.id_rol and
      sector.id_sector=sub_sector.id_sector and
      e.cv_sub_sector=sub_sector.id_sub_sector and
      e.cv_id_sector=sub_sector.id_sector;
--------------------------------------------------------
--  DDL for View V_FORMACIONS_CV
--------------------------------------------------------

  CREATE OR REPLACE FORCE VIEW "RELACIONAL"."V_FORMACIONS_CV" ("Candidat", "CV", "Formacio", "Tipus Formacio", "Data Inici", "Data Fi", "Descripcio", "Es Certificada") AS 
  select id_candidat_cv "Candidat",
       id_cv "CV",
       id_formacio "Formacio",
       tipus_formacions.desc_tipus_formacio "Tipus Formacio",
       data_inici_formacio "Data Inici",
       data_fi_formacio "Data Fi",
       descripcio_formacio "Descripcio",
       certificada "Es Certificada"
from cv_formacio,
     tipus_formacions
where cv_formacio.tipus_formacio=tipus_formacions.id_tipus_formacio;
--------------------------------------------------------
--  DDL for View V_IDIOMES_CV
--------------------------------------------------------

  CREATE OR REPLACE FORCE VIEW "RELACIONAL"."V_IDIOMES_CV" ("Candidat", "CV", "IDIOMA", "Nivell Parlat", "Nivell llegit", "Nivell Escrit") AS 
  select id_candidat_cv "Candidat",
       id_cv "CV",
       m_idioma.desc_idioma "IDIOMA",
       nv_parlat.desc_nivell "Nivell Parlat",
       nv_llegit.desc_nivell "Nivell llegit",
       nv_escrit.desc_nivell "Nivell Escrit"
from cv_idioma,
     m_idioma,
     nivell_idioma nv_llegit,
     nivell_idioma nv_parlat,
     nivell_idioma nv_escrit
where cv_idioma.id_idioma=m_idioma.id_idioma and
      cv_idioma.nivell_parlat=nv_parlat.id_nivell and
      cv_idioma.nivell_escrit= nv_escrit.id_nivell and
      cv_idioma.nivell_llegit = nv_llegit.id_nivell;
--------------------------------------------------------
--  DDL for View V_OFERTES_EMPRESA
--------------------------------------------------------

  CREATE OR REPLACE FORCE VIEW "RELACIONAL"."V_OFERTES_EMPRESA" ("Id Oferta", "Id Empresa", "CIF Empresa", "Data Alta Oferta", "Desc Curta Oferta", "Rol a desenvolupar", "Estat Oferta") AS 
  SELECT id_oferta "Id Oferta",
    id_empresa_oferta "Id Empresa",
    empresa.cif_empresa "CIF Empresa",
    o.data_alta "Data Alta Oferta",
    descripcio_curta_oferta "Desc Curta Oferta",
    r.desc_rol "Rol a desenvolupar",
    eo.desc_estat_oferta "Estat Oferta"
  FROM oferta o,
    mestre_rols r,
    empresa,
    estat_oferta eo
  WHERE o.rol_candidat_oferta=r.id_rol
  AND empresa.id_empresa     =o.id_empresa_oferta
  AND eo.id_estat_oferta     =o.estat_oferta;


  
-----------------------------------------------------------------------------------------
----------------PROCEDIMENTS, FUNCIONS I DISPARADORS ------------------------------------
-----------------------------------------------------------------------------------------

--------------------------------------------------------
--  DDL for Trigger TRIG_INSERT_LOG
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER "RELACIONAL"."TRIG_INSERT_LOG" 
AFTER INSERT ON TAULA_LOG 
BEGIN
  dbms_output.put_line('Inserint al log de incidencies');
END;
/
ALTER TRIGGER "RELACIONAL"."TRIG_INSERT_LOG" ENABLE;
--------------------------------------------------------
--  DDL for Function F_ACCEPTAR_CANDIDATURA
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_ACCEPTAR_CANDIDATURA" 
/*
Aquesta funcio serveix per donar una candidatura com acceptada.
Donats els identificadors de la oferta, es a dir, el sequencial de la oferta i
el identificador de la empresa; aixi com l'indetificador del cv inscrit, 
es a dir, l'identificador del candidat i el seu identificador de cv; passarem
a posar la candidatura com acceptada.
Recordar que només es poden acceptar les candidatures amb els estats:
1 - Candidatura enviada a l'empresa
2 - Candidatura en proces
*/
(
  PCONTACTE IN contacte.id_usuari%TYPE,
  POFERTA IN oferta.id_oferta%TYPE,
  PEMPRESA IN empresa.id_empresa%TYPE,
  PCANDIDAT IN candidat.id_usuari%TYPE,
  PCV IN curriculum.id_cv%TYPE
) RETURN NUMBER AS 
eEstatCandidatura EXCEPTION;
eContacte EXCEPTION;
eCV EXCEPTION;

v_Estat_Candidatura NUMBER;
v_Contacte_Trobat NUMBER;
v_CV_Actiu_Trobat NUMBER;
BEGIN
/*La primera validació es comprovar que el contacte te permis per administrar 
  les ofertes de l'empresa*/
select count(*) into v_Contacte_Trobat
from rel_contacte_empresa
where empresa_rel=PEMPRESA and contacte_rel=PCONTACTE;
IF(v_Contacte_Trobat=0)THEN RAISE eContacte; END IF;

/*La segona validacio sera per comprova que el cv existeix i 
no esta donat de baixa*/
select count(*) into v_CV_Actiu_Trobat
from curriculum
where id_candidat_cv = PCANDIDAT and id_cv = PCV and data_baixa_cv is null;
IF (v_CV_Actiu_Trobat=0) THEN RAISE eEstatCandidatura;END IF;

/*Com tercera validacio m'asseguro que la candidatura esta en estat:
1 - Candidatura enviada a l'empresa
2 - Candidatura en proces
*/
select count(*) into v_Estat_Candidatura
from candidatura
where id_oferta_candidatura=POFERTA and id_candidat_cv=PCANDIDAT and
      id_cv_candidatura=PCV and id_empresa_oferta=PEMPRESA and 
      (estat_candidatura=1 or estat_candidatura=2);
IF (v_Estat_Candidatura<>1)THEN RAISE eEstatCandidatura;
END IF;

/*Les validacions previes realitzades, canviem estat de candidatura*/
UPDATE candidatura SET ESTAT_candidatura = 3
WHERE id_oferta_candidatura=POFERTA and id_candidat_cv=PCANDIDAT and
      id_cv_candidatura=PCV and id_empresa_oferta=PEMPRESA;
UPDATE candidatura SET data_acceptacio = to_date(sysdate,'DD/MM/YYYY')
WHERE id_oferta_candidatura=POFERTA and id_candidat_cv=PCANDIDAT and
      id_cv_candidatura=PCV and id_empresa_oferta=PEMPRESA;           
return 1;

EXCEPTION
   WHEN eEstatCandidatura THEN 
         insertar_log('Acceptar candidatura: Nomes es poden acceptar les' ||
                       'candidatures existents i enviades a la empresa o '||
                       'En proces de seleccio.');
                           return -1;
   WHEN eContacte THEN 
         insertar_log('Acceptar candidatura: Aquest usuari no pot gestionar'||
                      ' les ofertes de la empresa: '||PEMPRESA);
                           return -1;
   WHEN eCV THEN 
         insertar_log('Acceptar candidatura: El Cv introduit no es correspon'||
                      ' amb cap CV actiu inscrit en aquesta oferta');
                           return -1;                          
  WHEN OTHERS THEN
         insertar_log('Acceptar candidatura: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;  

END F_ACCEPTAR_CANDIDATURA;

/

--------------------------------------------------------
--  DDL for Function F_ACTIVAR_OFERTA
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_ACTIVAR_OFERTA" 
/*
Aquesta funció activa la oferta introduïda per paràmetre
Les candidatures associades a aquesta oferta continuaran en el mateix estat
*/
(
  PEMPRESA IN empresa.id_empresa%TYPE,
  POFERTA IN oferta.id_oferta%TYPE,
  PCONTACTE IN contacte.id_usuari%TYPE
) RETURN NUMBER AS 

eContacte EXCEPTION;
eOferta EXCEPTION;

v_Contacte NUMBER;
v_Oferta NUMBER;
BEGIN
/*La primera validació es comprovar que el contacte te permis per administrar 
  les ofertes de l'empresa*/
select count(*) into v_contacte
from rel_contacte_empresa
where empresa_rel=PEMPRESA and contacte_rel=PCONTACTE;
IF(v_contacte=0)THEN RAISE eContacte; END IF;

/*La segona validacio es garantir que oferta existeix*/
select count(*) into v_oferta
from oferta
where id_empresa_oferta= PEMPRESA and id_oferta=POFERTA;
IF (v_oferta=0) THEN RAISE eOferta; END IF;

/*Actualitzem l'estat de la oferta a 1*/
UPDATE OFERTA SET ESTAT_OFERTA = 1 WHERE id_empresa_oferta=PEMPRESA 
                                     and id_oferta=POFERTA;
return 1;                                     
EXCEPTION
   WHEN eContacte THEN 
         insertar_log('Activar Oferta: Aquest contacte no pot gestionar'
                       ||' les ofertes de la empresa ' || PEMPRESA);
                           return -1;
   WHEN eOferta THEN 
         insertar_log('Activar Oferta: Oferta no trobada');
                           return -1;
                          
  WHEN OTHERS THEN
         insertar_log('Activar Oferta: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;  



END F_ACTIVAR_OFERTA;

/

--------------------------------------------------------
--  DDL for Function F_AFEGIR_CURRICULUM
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_AFEGIR_CURRICULUM" 
/*
Aquesta funcio serveix per afegir un curriculum a un usuari de tipus candidat
*/
(
  PIDUSUARI IN curriculum.id_candidat_cv%TYPE,  
  PDESCCV IN curriculum.descripcio_cv%TYPE  
) RETURN NUMBER AS 

e_No_Es_Candidat EXCEPTION;
e_No_Hi_Ha_Desc EXCEPTION;
e_Desc_Repetida EXCEPTION;
v_Candidat_Trobat NUMBER;
v_hi_ha_cv NUMBER;
BEGIN
/*Abans que res ens assegurem que hi ha descripcio per la descripcio del cv*/
IF (PDESCCV is NULL) THEN RAISE e_No_Hi_Ha_Desc;END IF;

/*Ara mirem que aquesta descripció no la tingui un altre cv*/
select count(*) into v_hi_ha_cv
from curriculum
where id_candidat_cv=PIDUSUARI and descripcio_cv=pdesccv;
IF (v_hi_ha_cv>0) THEN RAISE e_Desc_Repetida;END IF;
/*Mirem que l'ususari exisiteixi i que sigui un candidat*/
select count(*) into v_Candidat_Trobat 
from candidat where id_usuari=PIDUSUARI;
IF (v_Candidat_Trobat=0) THEN RAISE e_No_Es_Candidat; END IF;
/*Com l'usuari existeix i a mes es candidat afegim el cv*/   
insert into curriculum (id_candidat_cv,id_cv,data_alta_cv,data_baixa_cv,
                        descripcio_cv) values
                        (PIDUSUARI,seq_cv.nextval,to_date(sysdate,'DD/MM/RR'),
                        null,PDESCCV);
return 1;


/*Gestio d'excepcions*/
EXCEPTION
   WHEN e_No_Hi_Ha_Desc THEN 
         insertar_log('Afegir CV candidat: Descripcio de CV es obligatori i no' 
                       || 'esta informat');
                           return -1;
   WHEN e_No_Es_Candidat THEN 
         insertar_log('Afegir CV candidat: El identificador ' || PIDUSUARI || 
                           ' no pertany a cap candidat');
                           return -1;
   WHEN e_Desc_Repetida THEN 
         insertar_log('Afegir CV candidat: La descripcio ' || PDESCCV || 
                           ' ja esta introduida en un altre de cv del'||
                           ' usuari '||PIDUSUARI);
                           return -1;                           
                          
  WHEN OTHERS THEN
         insertar_log('Afegir CV candidat: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;
END F_AFEGIR_CURRICULUM ;

/

--------------------------------------------------------
--  DDL for Function F_AFEGIR_EMPRESA
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_AFEGIR_EMPRESA" 
/*
Aquseta funcio serveix per que un contacte pugui afegir una empresa a la base
de dades.
*/
(
  PCONTACTE IN contacte.id_usuari%TYPE,
  PNOMEMPRESA IN empresa.nom_empresa%TYPE,
  PCIFEMPRESA IN empresa.cif_empresa%TYPE,
  PNOMBRETREB IN empresa.nombre_treballadors%TYPE,
  PDESCEMPRESA IN empresa.descripcio_empresa%TYPE,
  PSUBSECTOR IN empresa.sub_sector_empresa%TYPE,
  PADRECAWEB IN empresa.adreca_web_empresa%TYPE,
  PSECTOR IN empresa.sector_empresa%TYPE
) RETURN NUMBER AS 

e_No_Es_Contacte EXCEPTION;
e_Empresa_Ja_Existent EXCEPTION;
v_Contacte_Trobat NUMBER;
v_Existeix_Empresa NUMBER;
v_Crear_Associacio NUMBER;
BEGIN
/*Primer comproven que realment el id d'usuari es de contacte*/
select count(*) into v_Contacte_Trobat 
from contacte where id_usuari=PCONTACTE;
IF (v_Contacte_Trobat=0) THEN RAISE e_No_Es_Contacte; END IF;

/*Despres hem de mirar que l'empresa no estigui ja donada d'alta previament.
  Per fer-ho utilitzarem la clau alternativa de empreses CIF*/
select count(*) into v_Existeix_Empresa 
from empresa where cif_empresa=PCIFEMPRESA;
IF (v_Existeix_Empresa>0) THEN RAISE e_Empresa_Ja_Existent; END IF;

/*Afegeixo la empresa a la taula de empreses*/
insert into empresa (id_empresa,nom_empresa,cif_empresa,data_alta,data_baixa,
                     nombre_treballadors,descripcio_empresa,sub_sector_empresa,
                     adreca_web_empresa,sector_empresa) values
                     (seq_empresa.nextval,PNOMEMPRESA,PCIFEMPRESA,
                     to_date(sysdate,'DD/MM/RR'),null,PNOMBRETREB,PDESCEMPRESA,
                     PSUBSECTOR,PADRECAWEB,PSECTOR);
/*Afeigir la relació entre el contacte i la empresa.
*/                     
v_Crear_Associacio:= F_ASSOCIAR_CONTACTE_EMPRESA(PCIFEMPRESA,PCONTACTE);                     
return 1;

EXCEPTION
   WHEN e_No_Es_Contacte THEN 
         insertar_log('Afegir empresa: El usuari  '||PCONTACTE ||
                      ' no és un contacte.');
                           return -1;
   WHEN e_Empresa_Ja_Existent THEN 
         insertar_log('Afegir empresa::ja hi ha una empresa amb CIF:' 
                      || PCIFEMPRESA || ' introduïda al sistema');
                           return -1;
                          
  WHEN OTHERS THEN
         insertar_log('Afegir empresa: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1; 


END F_AFEGIR_EMPRESA;

/

--------------------------------------------------------
--  DDL for Function F_AFEGIR_EXP_CV
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_AFEGIR_EXP_CV" 
/*Aquesta funcio afegeix una experiencia a un cv per un determinat candidat*/
(
  PIDCANDIDAT cv_experiencia.id_candidat_cv%TYPE,
  PIDCV cv_experiencia.id_cv%TYPE,
  PIDSECTOR cv_experiencia.cv_id_sector%TYPE,
  PIDSUBSECTOR cv_experiencia.cv_sub_sector%TYPE,
  PDATAINI cv_experiencia.data_inici_exp%TYPE,
  PDATAFI cv_experiencia.data_fi_exp%TYPE,
  PROL cv_experiencia.rol_exp%TYPE,
  PPERSONESCARREC cv_experiencia.persones_carrec%TYPE,
  PDESCRIPCIO cv_experiencia.descripcio_exp%TYPE
) RETURN NUMBER AS 
e_No_Es_Candidat EXCEPTION;
e_No_Es_CV_Candidat EXCEPTION;
v_Candidat_Trobat NUMBER;
v_CV_Trobat NUMBER;

BEGIN

/*Primer comproven que realment el id d'usuari es de candidat*/
select count(*) into v_Candidat_Trobat 
from candidat where id_usuari=PIDCANDIDAT;
IF (v_Candidat_Trobat=0) THEN RAISE e_No_Es_Candidat; END IF;
/*Segon comprovem que el id de cv es correspon a un codi de cv del candidat*/
select count(*) into v_CV_Trobat
from curriculum where id_cv = PIDCV;
IF (v_CV_Trobat=0) THEN RAISE e_No_Es_CV_Candidat; END IF;
/*Les primeres verifacions han donat resultats positius. procedima insertar*/
 INSERT INTO CV_EXPERIENCIA (ID_CANDIDAT_CV,ID_CV,ID_EXPERIENCIA,
             CV_ID_SECTOR,CV_SUB_SECTOR,DATA_INICI_EXP, DATA_FI_EXP, ROL_EXP,
             PERSONES_CARREC,DESCRIPCIO_EXP)
             VALUES (PIDCANDIDAT,PIDCV, SEQ_EXPERIENCIA.NEXTVAL, PIDSECTOR,
             PIDSUBSECTOR,PDATAINI,PDATAFI,PROL,PPERSONESCARREC,PDESCRIPCIO
             );
 RETURN 1;
 
 EXCEPTION
   WHEN e_No_Es_CV_Candidat THEN 
         insertar_log('Afegir experiencia CV: El CV  '||PIDCV ||
                      ' no pertany al candidat ' || PIDCANDIDAT);
                           return -1;
   WHEN e_No_Es_Candidat THEN 
         insertar_log('Afegir experiencia CV: El identificador ' || PIDCANDIDAT || 
                           ' no pertany a cap candidat');
                           return -1;
                          
  WHEN OTHERS THEN
         insertar_log('Afegir experiencia CV: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;
END F_AFEGIR_EXP_CV;

/

--------------------------------------------------------
--  DDL for Function F_AFEGIR_FORMACIO_CV
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_AFEGIR_FORMACIO_CV" 
(
  PIDCANDIDAT IN CV_FORMACIO.id_candidat_cv%TYPE,
  PIDCV IN CV_FORMACIO.id_cv%TYPE,
  PTIPUSFORMACIO IN cv_formacio.tipus_formacio%TYPE,
  PDATAINIFORM IN cv_formacio.data_inici_formacio%TYPE,
  PDATAFIFORM IN cv_formacio.data_fi_formacio%TYPE,
  PDESCFORM IN cv_formacio.descripcio_formacio%TYPE,
  PCERTFORM IN cv_formacio.descripcio_formacio%TYPE
) RETURN NUMBER AS 
e_No_Es_Candidat EXCEPTION;
e_No_Es_CV_Candidat EXCEPTION;
v_Candidat_Trobat NUMBER;
v_CV_Trobat NUMBER;
BEGIN

/*Primer comproven que realment el id d'usuari es de candidat*/
select count(*) into v_Candidat_Trobat 
from candidat where id_usuari=PIDCANDIDAT;
IF (v_Candidat_Trobat=0) THEN RAISE e_No_Es_Candidat; END IF;
/*Segon comprovem que el id de cv es correspon a un codi de cv del candidat*/
select count(*) into v_CV_Trobat
from curriculum where id_cv = PIDCV;
IF (v_CV_Trobat=0) THEN RAISE e_No_Es_CV_Candidat; END IF;
/*Les primeres verifacions han donat resultats positius. procedima insertar*/
insert into CV_FORMACIO (id_candidat_cv,id_cv,id_formacio,tipus_formacio,
                         data_inici_formacio,data_fi_formacio,
                         descripcio_formacio,certificada) VALUES
                         (PIDCANDIDAT,PIDCV,SEQ_FORMACIO.NEXTVAL,PTIPUSFORMACIO,
                         PDATAINIFORM,PDATAFIFORM,PDESCFORM,PCERTFORM);
RETURN 1;
EXCEPTION
   WHEN e_No_Es_CV_Candidat THEN 
         insertar_log('Afegir formacio CV: El CV  '||PIDCV ||
                      ' no pertany al candidat ' || PIDCANDIDAT);
                           return -1;
   WHEN e_No_Es_Candidat THEN 
         insertar_log('Afegir formacio CV: El identificador ' || PIDCANDIDAT || 
                           ' no pertany a cap candidat');
                           return -1;
                          
  WHEN OTHERS THEN
         insertar_log('Afegir formacio CV: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;         

END F_AFEGIR_FORMACIO_CV;

/

--------------------------------------------------------
--  DDL for Function F_AFEGIR_IDIOMA_CV
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_AFEGIR_IDIOMA_CV" 
/* Aquest funcio afegeix un idioma al cv d'un candidat*/
(
  PIDCANDIDAT IN CV_IDIOMA.id_candidat_cv%TYPE,
  PIDCV IN CV_IDIOMA.id_cv%TYPE,
  PIDIOMA IN cv_idioma.id_idioma%TYPE,
  PPARLAT IN cv_idioma.nivell_parlat%TYPE,
  PLLEGIT IN cv_idioma.nivell_llegit%TYPE,
  PESCRIT IN cv_idioma.nivell_escrit%TYPE
) RETURN NUMBER AS 
e_No_Es_Candidat EXCEPTION;
e_No_Es_CV_Candidat EXCEPTION;
v_Candidat_Trobat NUMBER;
v_CV_Trobat NUMBER;
BEGIN
/*Primer comproven que realment el id d'usuari es de candidat*/
select count(*) into v_Candidat_Trobat 
from candidat where id_usuari=PIDCANDIDAT;
IF (v_Candidat_Trobat=0) THEN RAISE e_No_Es_Candidat; END IF;
/*Segon comprovem que el id de cv es correspon a un codi de cv del candidat*/
select count(*) into v_CV_Trobat
from curriculum where id_cv = PIDCV;
IF (v_CV_Trobat=0) THEN RAISE e_No_Es_CV_Candidat; END IF;
/*Les primeres verifacions han donat resultats positius. procedima insertar*/
insert into cv_idioma (id_candidat_cv,id_cv,id_idioma,nivell_parlat,
                       nivell_llegit,nivell_escrit) values(
                       PIDCANDIDAT,PIDCV,PIDIOMA,PPARLAT,PLLEGIT,PESCRIT
                       );
 RETURN 1;
  EXCEPTION
   WHEN e_No_Es_CV_Candidat THEN 
         insertar_log('Afegir idioma CV: El CV  '||PIDCV ||
                      ' no pertany al candidat ' || PIDCANDIDAT);
                           return -1;
   WHEN e_No_Es_Candidat THEN 
         insertar_log('Afegir idioma CV: El identificador ' || PIDCANDIDAT || 
                           ' no pertany a cap candidat');
                           return -1;
                          
  WHEN OTHERS THEN
         insertar_log('Afegir idioma CV: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;                       
END F_AFEGIR_IDIOMA_CV;

/

--------------------------------------------------------
--  DDL for Function F_ASSOCIAR_CONTACTE_EMPRESA
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_ASSOCIAR_CONTACTE_EMPRESA" 
/*
  Aquesta funció serveix per associar un contacte a una empresa.
*/
(
  PCIF IN empresa.cif_empresa%TYPE,
  PCONTACTE IN contacte.id_usuari%TYPE
) RETURN NUMBER AS
e_No_Es_Contacte EXCEPTION;
e_Empresa_No_Existent EXCEPTION;
v_Contacte_Trobat NUMBER;
v_id_Empresa NUMBER;
BEGIN
/*Primer comproven que realment el id d'usuari es de contacte*/
select count(*) into v_Contacte_Trobat 
from contacte where id_usuari=PCONTACTE;
IF (v_Contacte_Trobat=0) THEN RAISE e_No_Es_Contacte; END IF;
/*Despres hem de mirar que l'empresa no estigui ja donada d'alta previament.
  Per fer-ho utilitzarem la clau alternativa de empreses CIF*/
select id_empresa into v_id_Empresa 
from empresa where cif_empresa=PCIF;
IF (v_id_Empresa is null) THEN RAISE e_Empresa_No_Existent; END IF;
 
/*El usuari és un contacte i el CIF pertany a una empresa- Es pot
  procedir a la inserció de la relació
*/
insert into rel_contacte_empresa (contacte_rel,empresa_rel)
values(PCONTACTE,v_id_Empresa);
return 1;
EXCEPTION
   WHEN e_No_Es_Contacte THEN 
         insertar_log('Associar contacte a empresa: El usuari  '||PCONTACTE ||
                      ' no és un contacte.');
                           return -1;
   WHEN e_Empresa_No_Existent THEN 
         insertar_log('Associar contacte a empresa:Hi ha cap empresa amb CIF:' 
                      || PCIF || ' introduïda al sistema');
                           return -1;
                          
  WHEN OTHERS THEN
         insertar_log('Associar contacte a empresa: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1; 

END F_ASSOCIAR_CONTACTE_EMPRESA;

/

--------------------------------------------------------
--  DDL for Function F_BLOQUEJA_USUARI
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_BLOQUEJA_USUARI" 
/*Aquesta funció bloqueja un usuari posant el seu flag de actiu a 0
  Entre els paràmetres hi ha el id del administrador que ho demana per assegurar
  que ho està demanant un administrador, que son els unics que poden bloquejar
  un usuari*/
(
  PADM IN usuari.id_usuari%TYPE,
  PUSR IN usuari.id_usuari%TYPE
) RETURN NUMBER AS 
e_No_Es_ADM EXCEPTION;
e_No_ES_USR EXCEPTION;
v_es_Adm NUMBER;
v_es_Usr NUMBER;
BEGIN
/*Comprovem que l'usuari que demana el bloqueig es administrador*/
select count(*) into v_es_Adm
from administrador adm,usuari usr
where adm.id_usuari=PADM and adm.id_usuari=usr.id_usuari and
      usr.actiu=1;
IF (v_es_Adm=0)THEN RAISE e_No_Es_ADM;END IF;

/*Comprovem que l'usuari a bloquejar existeix*/
select count(*) into v_es_Usr
from usuari
where id_usuari=PUSR;
IF (v_es_Usr=0)THEN RAISE e_No_ES_USR;END IF;

/*Podem actualitzar l'estat*/
UPDATE usuari SET actiu=0 where id_usuari=PUSR;

EXCEPTION
   WHEN e_No_Es_ADM THEN 
         insertar_log('Bloqueja usuari: Nomes pot bloquejar un usuari un administrador');
                           return -1;
   WHEN e_No_ES_USR THEN 
         insertar_log('Bloqueja usuari: Es es troba aquest usuari: '|| pusr);
                           return -1;                          
  WHEN OTHERS THEN
         insertar_log('Bloqueja usuari: codi: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;

END F_BLOQUEJA_USUARI;

/

--------------------------------------------------------
--  DDL for Function F_CANDIDATURA_EN_PROCES
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_CANDIDATURA_EN_PROCES" 
/*
Aquesta funcio serveix per marcar una candidatura com en proces.
Donats els identificadors de la oferta, es a dir, el sequencial de la oferta i
el identificador de la empresa; aixi com l'indetificador del cv inscrit, 
es a dir, l'identificador del candidat i el seu identificador de cv; passarem
a posar la candidatura com "en proces".
Recordar que només es poden posar en proces de seleccio les candidatures amb 
estat: 1 - Candidatura enviada a l'empresa
*/
(
  PCONTACTE IN contacte.id_usuari%TYPE,
  POFERTA IN oferta.id_oferta%TYPE,
  PEMPRESA IN empresa.id_empresa%TYPE,
  PCANDIDAT IN candidat.id_usuari%TYPE,
  PCV IN curriculum.id_cv%TYPE
) RETURN NUMBER AS 
eEstatCandidatura EXCEPTION;
eContacte EXCEPTION;
eCV EXCEPTION;

v_Estat_Candidatura NUMBER;
v_Contacte_Trobat NUMBER;
v_CV_Actiu_Trobat NUMBER;
BEGIN

/*La primera validació es comprovar que el contacte te permis per administrar 
  les ofertes de l'empresa*/
select count(*) into v_Contacte_Trobat
from rel_contacte_empresa
where empresa_rel=PEMPRESA and contacte_rel=PCONTACTE;
IF(v_Contacte_Trobat=0)THEN RAISE eContacte; END IF;

/*La segona validacio sera per comprova que el cv existeix i 
no esta donat de baixa*/
select count(*) into v_CV_Actiu_Trobat
from curriculum
where id_candidat_cv = PCANDIDAT and id_cv = PCV and data_baixa_cv is null;
IF (v_CV_Actiu_Trobat=0) THEN RAISE eEstatCandidatura;END IF;

/*Com tercera validacio m'asseguro que la candidatura esta en estat 
1 - Candidatura enviada a l'empresa
*/
select count(*) into v_Estat_Candidatura
from candidatura
where id_oferta_candidatura=POFERTA and id_candidat_cv=PCANDIDAT and
      id_cv_candidatura=PCV and id_empresa_oferta=PEMPRESA and 
      estat_candidatura=1;
IF (v_Estat_Candidatura<>1)THEN RAISE eEstatCandidatura;
END IF;

/*Les validacions previes realitzades, canviem estat de candidatura*/
UPDATE candidatura SET ESTAT_candidatura = 2
WHERE id_oferta_candidatura=POFERTA and id_candidat_cv=PCANDIDAT and
      id_cv_candidatura=PCV and id_empresa_oferta=PEMPRESA;
return 1;

EXCEPTION
   WHEN eEstatCandidatura THEN 
         insertar_log('Candidatura en proces: Nomes es poden posar en proces les' 
                    ||' candidatures existents en estat: '||
                      ' Candidatura enviada a empresa.');
                           return -1;
   WHEN eContacte THEN 
         insertar_log('Candidatura en proces: Aquest usuari no pot gestionar'||
                      ' les ofertes de la empresa: '||PEMPRESA);
                           return -1;
   WHEN eCV THEN 
         insertar_log('Candidatura en proces: El Cv introduit no es correspon'||
                      ' amb cap CV actiu inscrit en aquesta oferta');
                           return -1;                          
  WHEN OTHERS THEN
         insertar_log('Candidatura en proces: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;  






END F_CANDIDATURA_EN_PROCES;

/

--------------------------------------------------------
--  DDL for Function F_CERCA_ID_USUARI
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_CERCA_ID_USUARI" 
/*Si aquest funcio troba un usuari que tingui com a correu aquell que s'ha
  introduit com a parametre retornara el seu identificador, sino retorna -1*/
(
  PCORREU IN usuari.correu_usuari%TYPE  
) RETURN NUMBER AS 
v_id_usuari NUMBER;
v_ExisteixCorreu NUMBER;

BEGIN
/*Primer mirem si el correu esta donat d'alta*/
select count(*) into v_ExisteixCorreu 
from usuari where correu_usuari =pcorreu;
IF (v_ExisteixCorreu>0) THEN 
/*Si hi ha algun usuari amb aquell correu procedeixo a buscar el seu id*/
     select id_usuari into v_Id_Usuari from usuari 
     where correu_usuari=pcorreu;
     return v_Id_Usuari;
ELSE 
   /*Aquest correu noes correspon amb cap usuari*/
   return -1;   
END IF;
END F_CERCA_ID_USUARI;

/

--------------------------------------------------------
--  DDL for Function F_CREAR_ADMINISTRADOR
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_CREAR_ADMINISTRADOR" (
  PCORREU IN USUARI.CORREU_USUARI%TYPE,  
  PPASSWORD IN USUARI.PASSWORD_USUARI%TYPE,  
  PMATRICULA IN ADMINISTRADOR.CODI_MATRICULA%TYPE,
  PTELF IN ADMINISTRADOR.TELEFON%TYPE
)

RETURN NUMBER AS 
v_ExisteixCorreu NUMBER;
v_Id_Usuari  NUMBER;
e_Correu_Ja_Introduit EXCEPTION;

BEGIN
/* Aquest funcio crear un nou administrador*/
/*Primer mira de crear un usuari i després afegeix les dades propies de 
l'administrador*/
select count(*) into v_ExisteixCorreu 
from usuari where correu_usuari =pcorreu;

IF (v_ExisteixCorreu =0) THEN
  /*Com el correu no existeix a la base de dades*/
  /*Afegim l'usuari nou a la taula d'usuaris*/ 
  Insert into USUARI (ID_USUARI,CORREU_USUARI,PASSWORD_USUARI,
              DATA_ALTA,DATA_ULTIM_ACCES,ACTIU,tipus_usuari) values 
              (SEQ_USUARI.nextval,PCORREU,'contacte',to_date(sysdate,'DD/MM/RR'),
              to_date(sysdate,'DD/MM/RR'),1,1);
              
  /*Capturo el identificador d'usuari*/
  select id_usuari into v_Id_Usuari from usuari where correu_usuari=pcorreu;
  
  /*Inserto les dades del contacte*/              
  Insert into administrador (ID_USUARI,CODI_MATRICULA,TELEFON) values 
              (v_Id_Usuari,PMATRICULA,PTELF);     
              return 1;
ELSE
  /*Aquest correu ja pertany a algu. Abortar insercio*/
  RAISE e_Correu_Ja_Introduit;
END IF;
commit;
/*Control d'excepcions*/
EXCEPTION
   WHEN e_Correu_Ja_Introduit THEN 
         insertar_log('Crear administrador: el correu ' || PCORREU || 
                           ' ja esta assignat a un usuari');
                           return -1;
                          
  WHEN OTHERS THEN
         insertar_log('Crear administrador: codi: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;

        
END F_CREAR_ADMINISTRADOR;

/

--------------------------------------------------------
--  DDL for Function F_CREAR_CANDIDAT
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_CREAR_CANDIDAT" (
  PCORREU IN USUARI.CORREU_USUARI%TYPE,  
  PPASSWORD IN USUARI.PASSWORD_USUARI%TYPE,  
  PNOM IN contacte.nom%TYPE,
  PCOGNOM1 IN candidat.cognom1%TYPE,
  PCOGNOM2 IN candidat.cognom2%TYPE,
  PBUSCANT in candidat.esta_buscant%TYPE
)RETURN INTEGER AS 

v_ExisteixCorreu NUMBER;
v_Id_Usuari  NUMBER;
e_Correu_Ja_Introduit EXCEPTION;

BEGIN

/* Aquest funcio crear un nou candidat*/
/*Primer mira de crear un usuari i després afegeix les dades propies de 
candidat*/

/*Mirem si el correu ja esta donat d'alta*/
select count(*) into v_ExisteixCorreu 
from usuari where correu_usuari =pcorreu;

IF (v_ExisteixCorreu =0) THEN
  /*Com el correu no existeix a la base de dades*/
  /*Afegim l'usuari nou a la taula d'usuaris*/ 
  Insert into USUARI (ID_USUARI,CORREU_USUARI,PASSWORD_USUARI,
              DATA_ALTA,DATA_ULTIM_ACCES,ACTIU,tipus_usuari) values 
              (SEQ_USUARI.nextval,PCORREU,'candidat',to_date(sysdate,'DD/MM/RR'),
              to_date(sysdate,'DD/MM/RR'),1,1);
              
  /*Capturo el identificador d'usuari*/
  select id_usuari into v_Id_Usuari from usuari where correu_usuari=pcorreu;

  /*Inserto les dades del contacte*/              
  Insert into candidat (ID_USUARI,NOM,COGNOM1,COGNOM2,ESTA_BUSCANT) values 
              (v_Id_Usuari,PNOM,PCOGNOM1,PCOGNOM2, PBUSCANT);     
              return 1;
ELSE
  /*Aquest correu ja pertany a algu. Abortar insercio*/
  RAISE e_Correu_Ja_Introduit;
END IF;
commit;
/*Control d'excepcions*/
EXCEPTION
   WHEN e_Correu_Ja_Introduit THEN 
         rollback;
         insertar_log('Crear candidat: el correu ' || PCORREU || 
                           ' ja esta assignat a un usuari');
                           return -1;
                          
  WHEN OTHERS THEN
         rollback;
         insertar_log('Crear candidat: codi: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;


  RETURN 1;
END F_CREAR_CANDIDAT;

/

--------------------------------------------------------
--  DDL for Function F_CREAR_CONTACTE
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_CREAR_CONTACTE" 
/*
Aquesta funció crea un contacte a la base de dades. Per fer-ho haura
d'inserir dades a la taula d'usuaris i a la taula de contactes.
Com a paràmetres d'entrada conté totes les dades que el sistema necessita
per afegir un contacte.
*/
(
  PCORREU IN USUARI.CORREU_USUARI%TYPE,  
  PPASSWORD IN USUARI.PASSWORD_USUARI%TYPE,  
  PNIF IN CONTACTE.NIF%TYPE,
  PTELF1 IN contacte.telf1%TYPE,
  PTELF2 IN contacte.telf2%TYPE,
  PCORREU2 IN contacte.correu2%TYPE,
  PNOM IN contacte.nom%TYPE,
  PCOGNOM1 IN contacte.cognom1%TYPE,
  PCOGNOM2 IN contacte.cognom2%TYPE,
  PCARREC IN contacte.carrec%TYPE
) return number AS 

v_ExisteixCorreu NUMBER;
v_Id_Usuari  NUMBER;
e_Correu_Ja_Introduit EXCEPTION;

BEGIN
/* Aquest funcio crear un nou contacte d'empresa*/
/*Primer mira de crear un usuari i després afegeix les dades propies de 
contacte*/
select count(*) into v_ExisteixCorreu 
from usuari where correu_usuari =pcorreu;

IF (v_ExisteixCorreu =0) THEN
  /*Com el correu no existeix a la base de dades*/
  /*Afegim l'usuari nou a la taula d'usuaris*/ 
  Insert into USUARI (ID_USUARI,CORREU_USUARI,PASSWORD_USUARI,
              DATA_ALTA,DATA_ULTIM_ACCES,ACTIU,tipus_usuari) values 
              (SEQ_USUARI.nextval,PCORREU,'contacte',to_date(sysdate,'DD/MM/RR'),
              to_date(sysdate,'DD/MM/RR'),1,1);
              
  /*Capturo el identificador d'usuari*/
  select id_usuari into v_Id_Usuari from usuari where correu_usuari=pcorreu;
  
  /*Inserto les dades del contacte*/              
  Insert into CONTACTE (ID_USUARI,NIF,PRIORITAT,TELF1,TELF2,CORREU2,NOM,COGNOM1,
              COGNOM2,CARREC) values 
              (v_Id_Usuari,PNIF,1,PTELF1,PTELF2,PCORREU2,PNOM,PCOGNOM1,PCOGNOM2,
              PCARREC);     
              return 1;
ELSE
  /*Aquest correu ja pertany a algu. Abortar insercio*/
  RAISE e_Correu_Ja_Introduit;
END IF;
commit;
/*Control d'excepcions*/
EXCEPTION
   WHEN e_Correu_Ja_Introduit THEN 
         insertar_log('Crear contacte: el correu ' || PCORREU || 
                           ' ja esta assignat a un usuari');
                           return -1;
                          
  WHEN OTHERS THEN
         insertar_log('Crear contacte: codi: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;

        

END F_CREAR_CONTACTE;

/

--------------------------------------------------------
--  DDL for Function F_CREAR_OFERTA
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_CREAR_OFERTA" 
(
  PCONTACTE in contacte.id_usuari%TYPE,
  PCIFEMPRESA IN empresa.cif_empresa%TYPE,
  PPROVINCIA IN oferta.id_provincia_ciutat%TYPE,
  PDESCRIPCIO IN oferta.descripcio_oferta%TYPE,
  PREQMINIMS IN oferta.requeriements_minims_oferta%TYPE,
  PREQDESITJATS IN oferta.requeriments_desitjats_oferta%TYPE,
  PVACANTS IN oferta.nombre_vacants_oferta%TYPE,
  PSALARIMINIM IN oferta.salari_minim_oferta%TYPE,
  PSALARIMAXIM IN oferta.salari_maxim_oferta%TYPE,
  PTIPUSCONTRACTE IN oferta.tipus_contracte_oferta%TYPE,
  PTIPUSJORNADA IN oferta.tipus_jornada_oferta%TYPE,
  PCIUTAT IN oferta.ciutat_treball_oferta%TYPE,
  PROLCANDIDAT IN oferta.rol_candidat_oferta%TYPE,
  PDESCRIPCIOCURTA IN oferta.descripcio_curta_oferta%TYPE,
  PDATALIMIT IN oferta.data_limit%TYPE
) RETURN NUMBER AS 

e_EmpresaErronia EXCEPTION;
eContacte_No_Gestiona EXCEPTION;
e_Vacants_Negatiu EXCEPTION;
e_Data_Limit_Passat EXCEPTION;
e_Salari_Maxim_Minim EXCEPTION;
v_Empresa_id NUMBER;
v_contacte_gestiona_empresa NUMBER;

BEGIN

/*El nombre de vacants no pot ser 0 o negatiu*/
IF (PVACANTS<=0) THEN RAISE e_Vacants_Negatiu; END IF;

/*Comprovem que la data limit no sigui al passat*/
IF(PDATALIMIT<to_date(sysdate,'DD/MM/RR')) THEN RAISE e_Data_Limit_Passat; 
END IF;

/*Ara mirem que Salari minim no sigui major que el salari màxim*/
IF (PSALARIMINIM>PSALARIMAXIM) THEN RAISE e_Salari_Maxim_Minim; END IF;

/*Hem de mirar que l'empresa estigui ja donada d'alta previament.
  Per fer-ho utilitzarem la clau alternativa de empreses CIF*/
select count(*) into v_Empresa_id 
from empresa where cif_empresa=PCIFEMPRESA;
IF (v_Empresa_id=0) THEN RAISE e_EmpresaErronia; END IF;
/*Sabem que la empresa existeix i guardem el seu identificador*/
select id_empresa into v_Empresa_id 
from empresa where cif_empresa=PCIFEMPRESA;

/* Si l'empresa existeix mirem que la gestioni aquest contacte */
select count(*) into v_contacte_gestiona_empresa from rel_contacte_empresa
where contacte_rel=PCONTACTE and empresa_rel = v_Empresa_id;
IF (v_contacte_gestiona_empresa=0) THEN RAISE eContacte_No_Gestiona; END IF;

/*Validacions realitzades procedim a fer insert*/
insert into oferta (ID_EMPRESA_OFERTA,ID_OFERTA,ID_PROVINCIA_CIUTAT,
                    DATA_ALTA,DESCRIPCIO_OFERTA,
                    REQUERIEMENTS_MINIMS_OFERTA,REQUERIMENTS_DESITJATS_OFERTA,
                    NOMBRE_VACANTS_OFERTA,SALARI_MINIM_OFERTA,
                    SALARI_MAXIM_OFERTA,TIPUS_CONTRACTE_OFERTA,
                    TIPUS_JORNADA_OFERTA,CIUTAT_TREBALL_OFERTA,
                    ROL_CANDIDAT_OFERTA,DESCRIPCIO_CURTA_OFERTA,DATA_LIMIT,
                    ESTAT_OFERTA) values (
                    v_Empresa_id,seq_ofertes.nextval,PPROVINCIA,
                    to_date(sysdate,'DD/MM/YYYY'),PDESCRIPCIO,PREQMINIMS,
                    PREQDESITJATS,PVACANTS,PSALARIMINIM,PSALARIMAXIM,
                    PTIPUSCONTRACTE,PTIPUSJORNADA,PCIUTAT,PROLCANDIDAT,
                    PDESCRIPCIOCURTA,PDATALIMIT,1
                    );
return 1;

EXCEPTION
   WHEN e_EmpresaErronia THEN 
         insertar_log('Crear oferta: El CIF ' || PCIFEMPRESA || 
                           ' nom coincideix amb el de cap empresa del sistema');
                           return -1;
   WHEN eContacte_No_Gestiona THEN 
         insertar_log('Crear oferta: El contacte ' || PCONTACTE || 
                       ' no gestiona la empresa amb el CIF ' || PCIFEMPRESA ||
                       '.');
                           return -1;        
   WHEN e_Vacants_Negatiu THEN 
         insertar_log('Crear oferta: El nombre de vacants introduit es: ' ||
                       PVACANTS || '. El nombre de vacants no pot ser negatiu');
                           return -1;   
   WHEN e_Data_Limit_Passat THEN 
         insertar_log('Crear oferta:La data limit introduida per la oferta es: ' 
                      ||to_date(PDATALIMIT,'DD/MM/RR') || 
                      '. Aquesta data no pot ser inferior a la data de sistema'
                      );
                       return -1;   
   WHEN e_Salari_Maxim_Minim THEN 
         insertar_log('Crear oferta: El salari minim introduit es: ' ||
                       PSALARIMINIM || '.El salari maxim: '|| PSALARIMAXIM ||
                       '. El salari minim no pot ser major que el maxim');
                           return -1;                       
  WHEN OTHERS THEN
         insertar_log('Crear oferta: codi: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;

END F_CREAR_OFERTA;

/

--------------------------------------------------------
--  DDL for Function F_DEFINIR_ANTIGUETAT_TAULES
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_DEFINIR_ANTIGUETAT_TAULES" 
/*
Aquesta funció defineix el nombre de dies els registres d'una taula  
estarà al sistema. Per fer-ho actualitza el paràmetres temps (nombre de dies) 
per la taula entrada com a paràmetres.
Hem de revisar que el nou valor de dies sigui major que 0 i que el nom de la 
taula estigui a la taula de parametres_historic

*/
(
  PDIES IN NUMBER,
  PTAULA IN VARCHAR2
) RETURN NUMBER AS 
e_Taula_No_Existeix EXCEPTION;
e_Dies_Petit EXCEPTION;
v_Taula NUMBER;

BEGIN
/*Primer mirem que el nombre de dies sigui superior a 0*/
IF (PDIES<1) THEN RAISE e_Dies_Petit; END IF;
/*Ara mirem si la taula existeix*/
select count(*) into v_Taula
from parametres_historic
where nom_taula=PTAULA;
IF (v_Taula<>1) THEN RAISE e_Taula_No_Existeix; END IF;
/*Actualitzem el valor*/
UPDATE parametres_historic set temps=PDIES where nom_taula=PTAULA;
return 1;
EXCEPTION
   WHEN e_Taula_No_Existeix THEN 
         insertar_log('Definir Antiguetat Taules: La taula ' ||
                       PTAULA || ' no es parametritzable');
                           return -1;
   WHEN e_Dies_Petit THEN 
         insertar_log('Definir Antiguetat Taules: El nombre de dies ha de ser '||
                      'major que 0');
                           return -1;                   
  WHEN OTHERS THEN
         insertar_log('Definir Antiguetat Taules: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;  
END F_DEFINIR_ANTIGUETAT_TAULES;

/

--------------------------------------------------------
--  DDL for Function F_DESACTIVAR_OFERTA
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_DESACTIVAR_OFERTA" 
/*
Aquesta funció desativa la oferta introduïda per paràmetre
Si hi ha candidatures no acceptades penjant de la oferta,
aquestes passen automàticament a rebutjades.
*/
(
  PEMPRESA IN empresa.id_empresa%TYPE,
  POFERTA IN oferta.id_oferta%TYPE,
  PCONTACTE IN contacte.id_usuari%TYPE
) RETURN NUMBER AS 

eContacte EXCEPTION;
eOferta EXCEPTION;

v_Contacte NUMBER;
v_Oferta NUMBER;
BEGIN

/*La primera validació es comprovar que el contacte te permis per administrar 
  les ofertes de l'empresa*/
select count(*) into v_contacte
from rel_contacte_empresa
where empresa_rel=PEMPRESA and contacte_rel=PCONTACTE;
IF(v_contacte=0)THEN RAISE eContacte; END IF;

/*La segona validacio es garantir que oferta existeix*/
select count(*) into v_oferta
from oferta
where id_empresa_oferta= PEMPRESA and id_oferta=POFERTA;
IF (v_oferta=0) THEN RAISE eOferta; END IF;

/*Actualitzem l'estat de la oferta a 0*/
UPDATE OFERTA SET ESTAT_OFERTA = 0 WHERE id_empresa_oferta=PEMPRESA 
                                     and id_oferta=POFERTA;
/*Ara em de rebutjar totes les candidatures no acceptades*/ 
UPDATE candidatura SET ESTAT_CANDIDATURA = 0 WHERE id_empresa_oferta=PEMPRESA 
                                            and id_oferta_CANDIDATURA=POFERTA
                                            and estat_candidatura<>3;
return 1;                                            
EXCEPTION
   WHEN eContacte THEN 
         insertar_log('Desactivar Candidatura: Aquest contacte no pot gestionar'
                       ||' les ofertes de la empresa ' || PEMPRESA);
                           return -1;
   WHEN eOferta THEN 
         insertar_log('Desactivar Candidatura: Oferta no trobada');
                           return -1;
                          
  WHEN OTHERS THEN
         insertar_log('Desactivar Candidatura: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;                                            

END F_DESACTIVAR_OFERTA;

/

--------------------------------------------------------
--  DDL for Function F_DONAR_BAIXA_CV
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_DONAR_BAIXA_CV" 
/*
Aquesta funcio serveix per donar de baixa un cv. Per fer-ho informa la data
de baixa del cv seleccionat amb la data d'execucio de la funcio.
*/
(
  PCANDIDAT IN candidat.id_usuari%TYPE,
  PIDCV IN curriculum.id_cv%TYPE
) RETURN NUMBER AS
eCVNoTrobat EXCEPTION;
v_cv_ok NUMBER;
BEGIN
/*Primer validem que amb els parametres proporcionats hi ha un cv actiu*/
select count(*) into v_cv_ok
from curriculum
where id_candidat_cv=pcandidat and id_cv=PIDCV and data_baixa_cv is null;
IF (v_cv_ok=0) THEN RAISE eCVNoTrobat; END IF;
/*Hem validat que el cv existeix i esta actiu per tant el podem donar de baixa*/
UPDATE curriculum SET  data_baixa_cv = to_date(sysdate,'DD/MM/YYYY')
WHERE id_candidat_cv=pcandidat and id_cv=PIDCV;
return 1;

EXCEPTION
   WHEN eCVNoTrobat THEN 
         insertar_log('Donar de Baixa CV: No hi ha cap CV actiu del candidat '
                      ||pcandidat|| ' amb ID: ' ||PIDCV );
                           return -1;
  WHEN OTHERS THEN
         insertar_log('Donar de Baixa CV: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;
END F_DONAR_BAIXA_CV;

/

--------------------------------------------------------
--  DDL for Function F_ESBORRAR_CURRICULUM
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_ESBORRAR_CURRICULUM" 
/*
Aquesta funcio esborra un  currículum. El sistema actuarà de dues formes:
1 - Si cv no està associat a cap oferta, 
    es procedirà al seu esborrat de la base de dades.
2	Si està associat a alguna oferta, es donarà de baixa informant la data del 
  sistema com a data de baixa i no podrà ser utilitzar per cap oferta mes.
*/
(
  PIDUSUARI IN curriculum.id_candidat_cv%TYPE,
  PIDCV IN curriculum.id_cv%TYPE
) RETURN NUMBER AS 
e_No_Es_Candidat EXCEPTION;
e_No_Hi_Ha_CV EXCEPTION;
v_Candidat_Trobat NUMBER;
v_hi_ha_cv NUMBER;
v_inscrit_oferta NUMBER;
v_esborrat NUMBER;

BEGIN
/*Mirem que l'ususari exisiteixi i que sigui un candidat*/
select count(*) into v_Candidat_Trobat 
from candidat where id_usuari=PIDUSUARI;
IF (v_Candidat_Trobat=0) THEN RAISE e_No_Es_Candidat; END IF;
/*Comprovem que el identificador de cv es correspon amb un identificador per
aquest candidat*/
select count(*) into v_hi_ha_cv
from curriculum
where id_candidat_cv=pidusuari and id_cv=pidcv;
IF (v_hi_ha_cv=0) THEN RAISE e_No_Hi_Ha_CV;END IF;

/*Totes les validacions han acabat satifisfactoriament. Ara hem d'escollir quina
  opcio de baixa fem*/
/*Mirem si eñ cv forma part d'alguna candidatura. Si hi petany el desactivarem,
  si no és asixó l'esborrem*/  
select count(*) into v_inscrit_oferta
from candidatura
where id_candidat_cv=PIDUSUARI and id_cv_candidatura=PIDCV;

IF (v_inscrit_oferta=0) THEN
   /*Podem esborrar el cv*/
   delete from cv_experiencia where id_candidat_cv=PIDUSUARI and id_cv=PIDCV;
   delete from cv_formacio where id_candidat_cv=PIDUSUARI and id_cv=PIDCV;
   delete from cv_idioma where id_candidat_cv=PIDUSUARI and id_cv=PIDCV;
   delete from curriculum where id_candidat_cv=PIDUSUARI and id_cv=pidcv;
   v_esborrat:=1;
ELSE
   /*Nomes el podem donar de baixa*/
   v_esborrat:= f_donar_baixa_cv(PIDUSUARI,PIDCV);

END IF;   
return v_esborrat;
/*Gestio d'excepcions*/
EXCEPTION
   WHEN e_No_Es_Candidat THEN 
         insertar_log('Esborrar CV candidat: El identificador ' || PIDUSUARI || 
                           ' no pertany a cap candidat');
                           return -1;
   WHEN e_No_Hi_Ha_CV THEN 
         insertar_log('Esborrar CV candidat: El CV ' || pidcv || 
                           ' no pertany a candidat: '|| PIDUSUARI);
                           return -1;                           
                          
  WHEN OTHERS THEN
         insertar_log('Esborrar CV candidat: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;



END F_ESBORRAR_CURRICULUM;

/

--------------------------------------------------------
--  DDL for Function F_INSCRIURE_CANDIDATURA
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_INSCRIURE_CANDIDATURA" 
/*
L'objectiu d'aquesta funcio es inscriure un curriculum d'un candidat a una
a una oferta de feina.
*/
(
  POFERTA IN oferta.id_oferta%TYPE,
  PCANDIDAT IN candidat.id_usuari%TYPE,
  PCV IN curriculum.id_cv%TYPE,
  PEMPRESA IN empresa.id_empresa%TYPE,
  PCARTA IN candidatura.carta_candidatura%TYPE
) RETURN NUMBER AS 
eCandidat EXCEPTION;
eCandidat_Repe EXCEPTION;
eOferta_No_OK EXCEPTION;
eData_Limit EXCEPTION;
v_Candidat NUMBER;
v_oferta_ok NUMBER;
v_data_limit DATE;
BEGIN
/*Primer mirem que el candidat exiteix i es actiu*/
select count(usuari.id_usuari) into v_Candidat
from usuari, candidat
where usuari.id_usuari=candidat.id_usuari and usuari.actiu=1 and
      usuari.id_usuari=PCANDIDAT;
IF (v_Candidat=0) THEN RAISE eCandidat; END IF;

/*Despres mirem que existeix la oferta entrada per parametre i 
  que estugui activa*/
select count(oferta.id_oferta) into v_oferta_ok
from oferta
where oferta.id_empresa_oferta=PEMPRESA and oferta.id_oferta=POFERTA and 
      oferta.estat_oferta=1;
IF (v_oferta_ok=0) THEN RAISE eOferta_No_OK; END IF;

/*Ara ens assegurem que el candidat no s'ha inscrit amb un altre cv*/  
select count(candidatura.id_candidat_cv) into v_Candidat
from candidatura
where candidatura.id_candidat_cv=PCANDIDAT and
      candidatura.id_oferta_candidatura=POFERTA and
      candidatura.id_empresa_oferta=PEMPRESA;
IF (v_Candidat>0) THEN RAISE eCandidat_Repe; END IF; 

/*Validem que la data de sistema no sigui superior a la data límit de l'oferta
  si aquesta s'ha definit*/
Select data_limit into v_data_limit
from oferta
where id_oferta=POFERTA and id_empresa_oferta=PEMPRESA;

IF (v_data_limit is not null) THEN
   IF(v_data_limit<sysdate) THEN RAISE eData_Limit; END IF;
END IF;   

/*Fetes aquesta comprovacions ja podem afegir la candidatura*/
insert into candidatura(ID_OFERTA_CANDIDATURA,ID_CANDIDAT_CV,ID_CV_CANDIDATURA,
                        ID_EMPRESA_OFERTA,DATA_ALTA,
                        ESTAT_CANDIDATURA,CARTA_CANDIDATURA,DATA_ACCEPTACIO)
                        values(POFERTA,PCANDIDAT,PCV,PEMPRESA, 
                        to_date(sysdate,'DD/MM/YYYY'),1,PCARTA,null);
return 1;                        
EXCEPTION
   WHEN eCandidat THEN 
         insertar_log('Inscriure canidatura: No hi ha cap candidat actiu amb codi ' 
                       || PCANDIDAT || ' No efectuara la inscripcio');
                           return -1;
   WHEN eCandidat_Repe THEN 
         insertar_log('Inscriure canidatura: El candidat ' || PCANDIDAT || 
                       ' ja esta inscrit per aquesta oferta.');
                           return -1;        
   WHEN eOferta_No_OK THEN 
         insertar_log('Inscriure canidatura: La oferta introduida no es una oferta activa ');
                           return -1;    
   WHEN eData_Limit THEN 
         insertar_log('Inscriure canidatura: Data limit oferta superada. '|| 
                      'Data limit es: '||to_date(v_data_limit,'DD/MM/YYYY'));
                           return -1;                            
  WHEN OTHERS THEN
         insertar_log('Crear oferta: codi: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;
END F_INSCRIURE_CANDIDATURA;

/

--------------------------------------------------------
--  DDL for Function F_MODIFICAR_CURRICULUM
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_MODIFICAR_CURRICULUM" 
/*
Donat un candidat i un identificador de cv, aquesta funció serveix per
modificar la descripcio del curriculum, que és lúnic atribut que es pot 
modificar.
També es realitzaran les validacions pertinents.
*/
(
  PIDUSUARI IN curriculum.id_candidat_cv%TYPE,
  PIDCV IN curriculum.id_cv%TYPE,
  PDESCCV IN curriculum.descripcio_cv%TYPE
) RETURN NUMBER AS 

e_No_Es_Candidat EXCEPTION;
e_No_Hi_Ha_Desc EXCEPTION;
e_Desc_Repetida EXCEPTION;
e_No_Hi_Ha_CV EXCEPTION;
v_Candidat_Trobat NUMBER;
v_hi_ha_cv NUMBER;
BEGIN
/*Abans que res ens assegurem que hi ha descripcio per la descripcio del cv*/
IF (PDESCCV is NULL) THEN RAISE e_No_Hi_Ha_Desc;END IF;

/*Ara mirem que aquesta descripció no la tingui un altre cv*/
select count(*) into v_hi_ha_cv
from curriculum
where id_candidat_cv=PIDUSUARI and descripcio_cv=pdesccv;
IF (v_hi_ha_cv>0) THEN RAISE e_Desc_Repetida;END IF;
/*Mirem que l'ususari exisiteixi i que sigui un candidat*/
select count(*) into v_Candidat_Trobat 
from candidat where id_usuari=PIDUSUARI;
IF (v_Candidat_Trobat=0) THEN RAISE e_No_Es_Candidat; END IF;

/*Comprovem que el identificador de cv es correspon amb un identificador per
aquest candidat*/
select count(*) into v_hi_ha_cv
from curriculum
where id_candidat_cv=pidusuari and id_cv=pidcv;
IF (v_hi_ha_cv=0) THEN RAISE e_No_Hi_Ha_CV;END IF;

/*Arribat a aquest punt totes les validacions han finalitzat satisfactoriament
  Anem a modificar la descripcio*/
UPDATE curriculum SET descripcio_cv = PDESCCV 
WHERE id_candidat_cv=pidusuari and id_cv=pidcv;
return 1;

/*Gestio d'excepcions*/
EXCEPTION
   WHEN e_No_Hi_Ha_Desc THEN 
         insertar_log('Modificar CV candidat: Descripcio de CV es obligatori i no' 
                       || 'esta informat');
                           return -1;
   WHEN e_No_Es_Candidat THEN 
         insertar_log('Modificar CV candidat: El identificador ' || PIDUSUARI || 
                           ' no pertany a cap candidat');
                           return -1;
   WHEN e_Desc_Repetida THEN 
         insertar_log('Modificar CV candidat: La descripcio ' || PDESCCV || 
                           ' ja esta introduida en un altre de cv del'||
                           ' usuari '||PIDUSUARI);
                           return -1;  
   WHEN e_No_Hi_Ha_CV THEN 
         insertar_log('Modificar CV candidat: El CV ' || pidcv || 
                           ' no pertany a candidat: '|| PIDUSUARI);
                           return -1;                           
                          
  WHEN OTHERS THEN
         insertar_log('Modificar CV candidat: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;


END F_MODIFICAR_CURRICULUM;

/

--------------------------------------------------------
--  DDL for Function F_REBUTJAR_CANDIDATURA
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_REBUTJAR_CANDIDATURA" 
/*Aquesta funcio serveix per rebutjar una candidatura.
Donats els identificadors de la oferta, es a dir, el sequencial de la oferta i
el identificador de la empresa; aixi com l'indetificador del cv inscrit, 
es a dir, l'identificador del candidat i el seu identificador de cv; passarem
a posar la candidatura com rebutjada.
*/
(
  PCONTACTE IN contacte.id_usuari%TYPE,
  POFERTA IN oferta.id_oferta%TYPE,
  PEMPRESA IN empresa.id_empresa%TYPE,
  PCANDIDAT IN candidat.id_usuari%TYPE,
  PCV IN curriculum.id_cv%TYPE  
) RETURN NUMBER AS 
e_Contacte EXCEPTION;
e_No_Candidatura EXCEPTION;
v_Contacte_Trobat NUMBER;
v_hi_ha_Candidatura NUMBER;
BEGIN
/*Comprovem que el contacte te permis per administrar 
  les ofertes de l'empresa*/
select count(*) into v_Contacte_Trobat
from rel_contacte_empresa
where empresa_rel=PEMPRESA and contacte_rel=PCONTACTE;
IF(v_Contacte_Trobat=0)THEN RAISE e_Contacte; END IF;

/*Verifico que la candidatura existeix*/
select count(*) into v_hi_ha_Candidatura
from candidatura
where id_oferta_candidatura=POFERTA and id_candidat_cv=PCANDIDAT and
      id_cv_candidatura=PCV and id_empresa_oferta=PEMPRESA;
      
IF (v_hi_ha_Candidatura=0)THEN RAISE e_No_Candidatura;END IF;

/*Les validacions previes realitzades, canviem estat de candidatura*/
UPDATE candidatura SET ESTAT_candidatura = 0
WHERE id_oferta_candidatura=POFERTA and id_candidat_cv=PCANDIDAT and
      id_cv_candidatura=PCV and id_empresa_oferta=PEMPRESA;
return 1;

EXCEPTION
   WHEN e_Contacte THEN 
         insertar_log('Rebutjar candidatura: Aquest usuari no pot gestionar'||
                      ' les ofertes de la empresa: '||PEMPRESA);
                           return -1;
   WHEN e_No_Candidatura THEN 
         insertar_log('Rebutjar candidatura: La candidatura no existeix.');
                           return -1;                           
                         
   WHEN OTHERS THEN
         insertar_log('Rebutjar candidatura: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;  

END F_REBUTJAR_CANDIDATURA;

/

--------------------------------------------------------
--  DDL for Function F_TROBAR_CV
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_TROBAR_CV" 
/*
Aquesta funcio no es una funcio de suport. No desenvolupa cap funcionalitat
requerida pel client. Serveix per facilitat les proves de l'aplicacio
Aquesta en concret retorn l'identificador d'un cv a partir de l'identificador 
del seu candidat i la descripcio del cv
*/

(
  PUSRID IN usuari.id_usuari%TYPE,  
  PDESCRIPCIO IN curriculum.descripcio_cv%TYPE
) RETURN NUMBER AS
e_No_trobat EXCEPTION;
v_cv_id NUMBER;
BEGIN

select count(*) into v_cv_id
from curriculum
where id_candidat_cv=PUSRID and descripcio_cv=PDESCRIPCIO;
IF (v_cv_id=0) THEN RAISE e_No_trobat;END IF;

select id_cv  into v_cv_id
from curriculum
where id_candidat_cv=PUSRID and descripcio_cv=PDESCRIPCIO;
return v_cv_id;

EXCEPTION
   WHEN e_No_trobat THEN 
         insertar_log('Trobar CV: No trobem cap cv amb aquests parametres.');
                           return -1;                         
  WHEN OTHERS THEN
         insertar_log('Trobar CV: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;

END F_TROBAR_CV;

/

--------------------------------------------------------
--  DDL for Function F_TROBAR_ID_EMPRESA
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_TROBAR_ID_EMPRESA" 
/*
Aquesta funcio no es una funcio de suport. No desenvolupa cap funcionalitat
requerida pel client. Serveix per facilitat les proves de l'aplicacio
Aquesta en concret retorn l'identificador d'una empresa a partir del seu CIF
*/
(
  PCIF IN empresa.cif_empresa%TYPE  
) RETURN NUMBER AS
v_Id_Empresa NUMBER;
e_No_trobat EXCEPTION;
BEGIN

select count(id_empresa) into v_Id_Empresa
from empresa
where cif_empresa=PCIF;
IF (v_Id_Empresa=0) THEN RAISE e_No_trobat; END IF;

select id_empresa into v_Id_Empresa
from empresa
where cif_empresa=PCIF;

return v_id_empresa;

EXCEPTION
   WHEN e_No_trobat THEN 
         insertar_log('Trobar Empresa: No trobem cap empresa amb aquests parametres.');
                           return -1;                         
  WHEN OTHERS THEN
         insertar_log('Trobar Empresa: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;
END F_TROBAR_ID_EMPRESA;

/

--------------------------------------------------------
--  DDL for Function F_TROBAR_USR
--------------------------------------------------------

  CREATE OR REPLACE FUNCTION "RELACIONAL"."F_TROBAR_USR" 
/*
Aquesta funcio no es una funcio de suport. No desenvolupa cap funcionalitat
requerida pel client. Serveix per facilitat les proves de l'aplicacio
Aquesta en concret retorn l'identificador d'un usuari a partir del seu correu
*/
(
  PCORREU IN usuari.correu_usuari%TYPE  
) RETURN NUMBER AS 
v_id_usr NUMBER;
e_No_trobat EXCEPTION;
BEGIN

select count(id_usuari) into v_id_usr
from usuari
where correu_usuari=PCORREU;
IF(v_id_usr=0) THEN RAISE e_No_trobat; END IF;

select id_usuari into v_id_usr
from usuari
where correu_usuari=PCORREU;
return v_id_usr;

EXCEPTION
   WHEN e_No_trobat THEN 
         insertar_log('Trobar USR: No trobem cap usuari amb aquests parametres.');
                           return -1;                         
  WHEN OTHERS THEN
         insertar_log('Trobar USR: '|| 
                             SQLCODE ||  ' - '||
                             substr(SQLERRM, 1,200));  
                             return -1;

END F_TROBAR_USR;

/

--------------------------------------------------------
--  DDL for Procedure ACTIVAR_CONSTRAINTS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "RELACIONAL"."ACTIVAR_CONSTRAINTS" AS 
BEGIN
/*Activar constraints*/
  BEGIN
      FOR rec IN ( SELECT constraint_name, table_name FROM user_constraints where status = 'DISABLED' )
      LOOP
        BEGIN
          EXECUTE IMMEDIATE 'alter table '||rec.table_name||' enable NOVALIDATE constraint '||rec.constraint_name;
          dbms_output.put_line('alter table '||rec.table_name||' enable NOVALIDATE constraint '||rec.constraint_name);
        EXCEPTION
          WHEN OTHERS THEN
            dbms_output.put_line('ERROR: alter table '||rec.table_name||' enable NOVALIDATE constraint '||rec.constraint_name||' ;' );
            
        END;
      END LOOP;
    END;
                DBMS_OUTPUT.PUT_LINE('CONSTRAINTS ENABLED');
    BEGIN
      FOR rec IN ( SELECT trigger_name FROM user_triggers WHERE TRIGGER_NAME NOT LIKE 'BIN$%' )
      LOOP
          EXECUTE IMMEDIATE 'alter trigger '||rec.trigger_name||' enable';
      END LOOP;
    END;
                DBMS_OUTPUT.PUT_LINE('TRIGGERS ENABLED');
END ACTIVAR_CONSTRAINTS;

/

--------------------------------------------------------
--  DDL for Procedure DESACTIVAR_CONSTRAINTS
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "RELACIONAL"."DESACTIVAR_CONSTRAINTS" AS 
/*Aquest procediment desactiva les constraints*/
BEGIN
/**Desactivar constraints*/
    BEGIN
      FOR rec IN ( SELECT trigger_name FROM user_triggers WHERE TRIGGER_NAME NOT LIKE 'BIN$%' )
      LOOP
            EXECUTE IMMEDIATE 'alter trigger '||rec.trigger_name||' disable';
      END LOOP;
    END;
    DBMS_OUTPUT.PUT_LINE('TRIGGERS DISABLED');
    BEGIN
      FOR rec IN ( SELECT constraint_name, table_name FROM user_constraints WHERE constraint_type = 'R' )
      LOOP
        BEGIN
        EXECUTE IMMEDIATE 'alter table '||rec.table_name||' disable constraint '||rec.constraint_name;
         EXCEPTION WHEN OTHERS THEN
             dbms_output.put_line( 'ERROR: alter table '||rec.table_name||' DISABLE constraint '||rec.constraint_name||';' );
        END;      
      END LOOP;
      DBMS_OUTPUT.PUT_LINE('Constraints DISABLED');
    END;


END DESACTIVAR_CONSTRAINTS;

/

--------------------------------------------------------
--  DDL for Procedure ESBORRAR_TOTES_TAULES
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "RELACIONAL"."ESBORRAR_TOTES_TAULES" AS 
 v_statement VARCHAR2 (200);
BEGIN

/*Desactivem les restriccions*/
 DESACTIVAR_CONSTRAINTS;


/* Esborrar tot*/
BEGIN
 FOR i IN (SELECT *
   FROM user_tables)
  LOOP
  v_statement :=
 'delete ' || i.table_name ;
 EXECUTE IMMEDIATE v_statement;
 END LOOP;
END;

/*Activem les restriccions*/
ACTIVAR_CONSTRAINTS;

END ESBORRAR_TOTES_TAULES;

/

--------------------------------------------------------
--  DDL for Procedure EXECUTA_NETEJA
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "RELACIONAL"."EXECUTA_NETEJA" AS 
/*Aquest procediments executa les neteges dels registres massa antics per
  les taules que hi ha introduides a la taula parametres historic */
v_Taula VARCHAR2(200);
v_dies NUMBER;
v_data DATE;
v_sentencia VARCHAR(1000);
CURSOR c_Taules is
   Select nom_taula,temps from parametres_historic;

BEGIN

OPEN c_Taules;
LOOP
    FETCH c_Taules into v_Taula,v_dies;
    v_data:= to_date(sysdate,'DD/MM/YYYY')-v_dies;
    /*insertar_log('delete from '||v_Taula || ' where data_alta>='
    ||to_date(v_data,'DD/MM/YYYY'));*/
    v_sentencia:='delete from '||v_Taula || 
                ' where to_date(data_alta,''DD/MM/YYYY'')<=to_date('''||
                  to_date(v_data,'DD/MM/YYYY')||''',''DD/MM/YYYY'')';
      /*insertar_log('EXECUTA_NETEJA: Setència: ' || v_sentencia); */ 
      DBMS_OUTPUT.PUT_LINE(v_sentencia);
      EXECUTE IMMEDIATE v_sentencia;
      insertar_log('EXECUTA_NETEJA: S''han esborrat '||SQL%ROWCOUNT ||
                 ' registres de '|| v_Taula);
    EXIT WHEN c_Taules%NOTFOUND;
END LOOP;
CLOSE c_Taules;

END EXECUTA_NETEJA;

/

--------------------------------------------------------
--  DDL for Procedure INSERTAR_LOG
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "RELACIONAL"."INSERTAR_LOG" 
(
  P_DESCRIPCIO IN taula_log.descripcio_problema%TYPE  
) AS 
BEGIN
INSERT INTO taula_log (id_log, data_alta, descripcio_problema)values 
            (seq_log.nextval,to_date(sysdate,'DD/MM/YYYY HH24:MI:SS')
            ,p_descripcio);
END INSERTAR_LOG;

/

--------------------------------------------------------
--  DDL for Procedure PROC_JOC_PROVES
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "RELACIONAL"."PROC_JOC_PROVES" AS 
/*
Aquest procediment executa ujn joc de proves i gaurda tots els resultats a la 
taula T_JOC_PROVES
*/
v_resultat number;
v_oferta NUMBER;
BEGIN

-- PAS 1: CREACIO DE DOS USUARIS DE CADA TIPUS 
--Afegim dos contactes d'empresa
--Contacte de proves 1
v_resultat := f_crear_contacte('contacteProva1@correu.com','password','NIFPr1',
              'tel1','tel2','correu2','nomContacteProva1',
              'cognom1Contact1','congnom2Contact1','carrec contacte prova 1');

if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Hen creat contacte: contacteProva1@correu.com');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al crear contacte: contacteProva1@correu.com');
end if;
--Contacte de proves 2
v_resultat := f_crear_contacte('contacteProva2@correu.com','password','NIFPr2',
              'tel1','tel2','correu2','nomContacteProva2',
              'cognom1Contact2','congnom2Contact2','carrec contacte prova 1');

if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Hen creat contacte: contacteProva2@correu.com');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al crear contacte: contacteProva2@correu.com');
end if;

--Afegir Candidats
-- Candidat de proves 1
v_resultat := f_crear_candidat('candidatProves1@correu.com','password1','nomCandidatProves1','cognom1CandidatPr1','congnom2CandidatPr1',1);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'insercio correcta candidat: candidatProves1@correu.com');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'insercio incorrecta candidat: candidatProves1@correu.com');
end if;
-- Candidat de proves 2
v_resultat := f_crear_candidat('candidatProves2@correu.com','password3','nomCandidatProves2','cognom1CandidatPr2','congnom2CandidatPr2',1);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'insercio correcta candidat: candidatProves1@correu.com');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'insercio incorrecta candidat: candidatProves1@correu.com');
end if;

--Afegir administradors
v_resultat := f_crear_administrador('correuADMProves1@correu.com','password1',22,'999999');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'insercio correcta administrador: correuADMProves1@correu.com');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'insercio incorrecta administrador: correuADMProves1@correu.com');
end if;

v_resultat := f_crear_administrador('correuADMProves2@correu.com','password2',23,'999999');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'insercio correcta administrador: correuADMProves2@correu.com');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'insercio incorrecta administrador: correuADMProves1@correu.com');
end if;


--PAS 2: Crear 3 empreses, 2 al contacte contacteProva1@correu.com i una per contacteProva2@correu.com
v_resultat := F_AFEGIR_EMPRESA(f_trobar_usr('contacteProva1@correu.com'),'Empresa 1','CIFE1',30,'Empresa de IT',1,'www.empresa1.com',1);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Empresa afegida per contacteProva1@correu.com');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir empresa per contacte contacteProva1@correu.com');
end if;
v_resultat := F_AFEGIR_EMPRESA(f_trobar_usr('contacteProva1@correu.com'),'Empresa 2','CIFE2',15,'Empresa de viatges',1,'www.empresa2.com',1);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Empresa afegida per contacteProva1@correu.com');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir empresa per contacte contacteProva1@correu.com');
end if;
v_resultat := F_AFEGIR_EMPRESA(f_trobar_usr('contacteProva2@correu.com'),'Empresa 3','CIFE3',1000,'Empresa de automocio',1,'www.empresa3.com',1);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Empresa afegida per contacteProva2@correu.com');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'Empresa afegida per contacteProva2@correu.com');
end if;

--PAS 3: Associar el contacte contacteProva2@correu.com a una empresa de contacteProva1@correu.com
v_resultat := F_ASSOCIAR_CONTACTE_EMPRESA('CIFE1',f_trobar_usr('contacteProva2@correu.com'));
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Empresa i contacte relacionats');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al relacionar empresa');
end if;

-- PAS 4: Afegim 3 ofertes. Una per l'empresa 1 i dues per l'empresa 3
v_resultat := F_CREAR_OFERTA(f_trobar_usr('contacteProva1@correu.com'),'CIFE1',1,'DESCRIPCIO LLARGA OFERTA 1','REQUERIMENTS MINIMS', 
                            'REQUERIMENTS DESITJATS',10,15000,20000,1,1,1,1,'DESCCURTA1',to_date('28/12/2013','DD/MM/YYYY'));                             
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Oferta afegida per Empresa 1');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir oferta per empresa 1');
end if;

v_resultat := F_CREAR_OFERTA(f_trobar_usr('contacteProva2@correu.com'),'CIFE3',1,'DESCRIPCIO LLARGA OFERTA 2','REQUERIMENTS MINIMS', 
                            'REQUERIMENTS DESITJATS',10,15000,20000,1,1,1,1,'DESCCURTA2',to_date('28/12/2013','DD/MM/YYYY'));                             
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Oferta afegida per Empresa 3');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir oferta per Empresa 3');
end if;

v_resultat := F_CREAR_OFERTA(f_trobar_usr('contacteProva2@correu.com'),'CIFE3',1,'DESCRIPCIO LLARGA OFERTA 3','REQUERIMENTS MINIMS', 
                            'REQUERIMENTS DESITJATS',10,15000,20000,1,1,1,1,'DESCCURTA3',to_date('28/12/2013','DD/MM/YYYY'));                             
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Oferta afegida per Empresa 3');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir oferta per Empresa 3');
end if;

--PAS 5: Afegirem 2 curriculums un per cada candidat
--       cada cv tindra 2 experiencies, dos formacions i dos idiomes.
--aFEGINT CURRICULUMS ALS CANDIDATS

v_resultat := f_AFEGIR_CURRICULUM(f_trobar_usr('candidatProves1@correu.com'),'Curriculum Candidat1 prova');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'curriculum candidat prova 1 ok');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al entrar curriculum candidat prova 1');
end if;

v_resultat := f_AFEGIR_CURRICULUM(f_trobar_usr('candidatProves2@correu.com'),'Curriculum Candidat2 prova');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'curriculum candidat prova 2 ok');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al entrar curriculum candidat prova 2');
end if;

--Afegint experiencia als cvs
v_resultat := F_AFEGIR_EXP_CV(f_trobar_usr('candidatProves1@correu.com'),1,1,1,to_date(sysdate,'DD/MM/RR'),to_date(sysdate,'DD/MM/RR'),0,
                              50, 'Esclavista IT');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Experiencia afegida a cv 1 de candidat prova 1');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'Problemes al afegir experiencia a cv 1 de candidat prova 1');
end if;

v_resultat := F_AFEGIR_EXP_CV(f_trobar_usr('candidatProves1@correu.com'),1,1,2,to_date(sysdate,'DD/MM/RR'),to_date(sysdate,'DD/MM/RR'),0,
                              20, 'Venedor de carn');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Experiencia afegida a cv 1 de candidat prova 1');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'Problemes al afegir experiencia a cv 1 de candidat prova 1');
end if;
v_resultat := F_AFEGIR_EXP_CV(f_trobar_usr('candidatProves2@correu.com'),2,1,1,to_date(sysdate,'DD/MM/RR'),to_date(sysdate,'DD/MM/RR'),0,
                              50, 'Esclavista IT');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Experiencia afegida a cv 1 de candidat prova 2');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'Problemes al afegir experiencia a cv 1 de candidat prova 2');
end if;

v_resultat := F_AFEGIR_EXP_CV(f_trobar_usr('candidatProves2@correu.com'),2,1,2,to_date(sysdate,'DD/MM/RR'),to_date(sysdate,'DD/MM/RR'),0,
                              20, 'Venedor de carn');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Experiencia afegida a cv 1 de candidat prova 2');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'Problemes al afegir experiencia a cv 1 de candidat prova 2');
end if;
-- Afegint idiomes al cv
v_resultat := F_AFEGIR_idioma_CV(f_trobar_usr('candidatProves1@correu.com'),1,0,3,3,3);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'idioma afegit');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir idioma candidat 1');
end if;
v_resultat := F_AFEGIR_idioma_CV(f_trobar_usr('candidatProves1@correu.com'),1,1,2,2,2);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'idioma afegit');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir idioma candidat 1');
end if;
v_resultat := F_AFEGIR_idioma_CV(f_trobar_usr('candidatProves2@correu.com'),2,0,3,3,3);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'idioma afegit candidat 2');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir idioma candidat 2');
end if;
v_resultat := F_AFEGIR_idioma_CV(f_trobar_usr('candidatProves2@correu.com'),2,1,2,2,2);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'idioma afegit candidat 2');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir idioma candidat 2');
end if;
--Afegint formacions al cv
v_resultat := F_AFEGIR_formacio_CV(f_trobar_usr('candidatProves1@correu.com'),1,1,to_date(sysdate,'DD/MM/RR'),
                                   to_date(sysdate,'DD/MM/RR'),'Disseny de bases de dades',0);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'formacio afegida candidat 1');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir formacio');
end if;
v_resultat := F_AFEGIR_formacio_CV(f_trobar_usr('candidatProves1@correu.com'),1,4,to_date(sysdate,'DD/MM/RR'),
                                   to_date(sysdate,'DD/MM/RR'),'Informatica',1);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'formacio afegida candidat 1');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir formacio');
end if;
v_resultat := F_AFEGIR_formacio_CV(f_trobar_usr('candidatProves2@correu.com'),2,1,to_date(sysdate,'DD/MM/RR'),
                                   to_date(sysdate,'DD/MM/RR'),'Disseny de bases de dades',0);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'formacio afegida candidat 2');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir formacio');
end if;
v_resultat := F_AFEGIR_formacio_CV(f_trobar_usr('candidatProves2@correu.com'),2,4,to_date(sysdate,'DD/MM/RR'),
                                   to_date(sysdate,'DD/MM/RR'),'Informatica',1);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'formacio afegida candidat 2');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir formacio');
end if;

-- PAS 6: Inscriure els candidats a les ofertes
--        Inscriurem tots dos candidats a dues ofertes
--Afegim la candidatura
v_resultat := F_INSCRIURE_CANDIDATURA(1,f_trobar_usr('candidatProves1@correu.com'),1,f_trobar_id_empresa('CIFE1'),
                        'Crec que compleixo els seus requeriments desitjats');                             
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'candidatura candidat 1 afegida a oferta d''empresa 1');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir candidatura candidat 1 a oferta d''empresa 1');
end if;
v_resultat := F_INSCRIURE_CANDIDATURA(1,f_trobar_usr('candidatProves2@correu.com'),2,f_trobar_id_empresa('CIFE1'),
                        'Crec que compleixo els seus requeriments desitjats');                             
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'candidatura candidat 2 afegida a oferta d''empresa 1');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir candidatura candidat 2a oferta d''empresa 1');
end if;
v_resultat := F_INSCRIURE_CANDIDATURA(2,f_trobar_usr('candidatProves1@correu.com'),1,f_trobar_id_empresa('CIFE3'),
                        'Crec que compleixo els seus requeriments desitjats');                             
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'candidatura candidat 1 afegida a oferta d''empresa 3');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir candidatura candidat 1 a oferta d''empresa 3');
end if;
v_resultat := F_INSCRIURE_CANDIDATURA(2,f_trobar_usr('candidatProves2@correu.com'),2,f_trobar_id_empresa('CIFE3'),
                        'Crec que compleixo els seus requeriments desitjats');                             
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'candidatura candidat 2 afegida a oferta d''empresa 3');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir candidatura candidat 2a oferta d''empresa 3');
end if;

-- PAS 7: modificar i eliminar curriculums.
-- Per no afectar a les altres proves, afegirem un curriculum a l'usuari candidatProves1@correu.com i despres, el modificarem, per finalment
-- esborrar el cv. Com el cv no està inscrit a cap oferta, l'esborrarem definitivament
v_resultat := f_AFEGIR_CURRICULUM(f_trobar_usr('candidatProves1@correu.com'),'Curriculum Candidat1 Esborrable');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'curriculum candidat 1 esborrable ok');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al entrar curriculum candidat 1 esborrable');
end if;
--CV creat ara modefiquem la descripcio
v_resultat:=f_modificar_curriculum(f_trobar_usr('candidatProves1@correu.com'),f_trobar_cv(f_trobar_usr('candidatProves1@correu.com'),'Curriculum Candidat1 Esborrable'),
                                   'CV candidat 1 modificat');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'curriculum candidat 1 modificat');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al modificar curriculum candidat 1');
end if;
-- CV modificat, ara el podem eliminar
v_resultat:=f_esborrar_curriculum(f_trobar_usr('candidatProves1@correu.com'),f_trobar_cv(f_trobar_usr('candidatProves1@correu.com'),'CV candidat 1 modificat'));
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'curriculum candidat 1 eliminat');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al eliminar curriculum candidat 1');
end if;

-- PAS 8 Desactivem una oferta. Automaticament les candidatures que hi ha associades passen a rebutjades.
--       Un cop fet això la tornem a activar.
--Desactivar Oferta
v_resultat:=f_desactivar_oferta(f_trobar_id_empresa('CIFE3'),2,f_trobar_usr('contacteProva2@correu.com'));
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Desactivada oferta empresa 3');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al desactivar oferta empresa 3');
end if;

--Activar Oferta
v_resultat:=f_activar_oferta(f_trobar_id_empresa('CIFE3'),2,f_trobar_usr('contacteProva2@correu.com'));
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Activada oferta empresa 3');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al activar oferta empresa 3');
end if;

-- PAS 9: Gestió de candidatures.
--        Primer posem les dues candidatures en procés de oferta activa
--        Segon acceptem una candidatura
--        Tercer rebutgem l'altra

-- Posant les dues candidatures en procés
v_resultat:=f_candidatura_en_proces(f_trobar_usr('contacteProva1@correu.com'),1,f_trobar_id_empresa('CIFE1'),
                                    f_trobar_usr('candidatProves1@correu.com'),1);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Candidatura 1 en proces');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al posar candidatura 1 en proces');
end if;
v_resultat:=f_candidatura_en_proces(f_trobar_usr('contacteProva2@correu.com'),1,f_trobar_id_empresa('CIFE1'),
                                    f_trobar_usr('candidatProves2@correu.com'),2);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Candidatura 2 en proces');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al posar candidatura 2 en proces');
end if;

v_resultat:=f_acceptar_candidatura(f_trobar_usr('contacteProva1@correu.com'),1,f_trobar_id_empresa('CIFE1'),
                                    f_trobar_usr('candidatProves1@correu.com'),1);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Candidatura 1 acceptada');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al posar candidatura 1 acceptada');
end if;

v_resultat:=f_rebutjar_candidatura(f_trobar_usr('contacteProva1@correu.com'),1,f_trobar_id_empresa('CIFE1'),
                                    f_trobar_usr('candidatProves2@correu.com'),2);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Candidatura 2 acceptada');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al posar candidatura 2 acceptada');
end if;

--PAS 10: Esborrar curriculums
--          Esborrar curriculum inscrit en oferta: Donar de Baixa
--          Esborrar curriculum no inscrit en oferta: Esborrar


--          Esborrar curriculum inscrit en oferta: Donar de Baixa
v_resultat:= f_esborrar_curriculum(f_trobar_usr('candidatProves2@correu.com'),2);
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'CV donat de baixa');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al posar CV de baixa');
end if;
 --         Esborrar curriculum no inscrit en oferta: Esborrar
--          Primer dono un cv d'alta i després l'esborro
v_resultat := f_AFEGIR_CURRICULUM(f_trobar_usr('candidatProves2@correu.com'),'Curriculum Candidat2 CV Esborrar');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'curriculum candidat 2');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al entrar curriculum candidat 2');
end if;
v_resultat:= f_esborrar_curriculum(f_trobar_usr('candidatProves2@correu.com'),
             f_trobar_cv(f_trobar_usr('candidatProves2@correu.com'),'Curriculum Candidat2 CV Esborrar'));
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'CV Candidat 2 esborrat');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al esobrrar curriculum candidat 2');
end if;

-- PAS 11: Parametritzar el control d'historics
-- Definir antiguetat per les ofertes
-- Definir antiguetat per les candidatures
-- Definir antiguetat pel log
-- Afegir Ofertes i modificar data d'alta per ser esborrades
-- Afegir candidatures i modificar data d'alta per ser esborrades
-- Afegir logs i modificar data d'alta per ser esborrats
-- Executar neteja

-- Definir antiguetat per les ofertes
-- Definir antiguetat per les candidatures
-- Definir antiguetat pel log
v_resultat:= f_definir_antiguetat_taules(100,'OFERTA');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Oferta 100 dies d''antiguetat');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al definir Oferta 100 dies d''antiguetat');
end if;
v_resultat:= f_definir_antiguetat_taules(100,'CANDIDATURA');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Candidatura 100 dies d''antiguetat');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al definir Candidatura 100 dies d''antiguetat');
end if;
v_resultat:= f_definir_antiguetat_taules(100,'TAULA_LOG');
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'Taula_Log 100 dies d''antiguetat');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al definir Taula_Log 100 dies d''antiguetat');
end if;

-- Afegir Ofertes i modificar data d'alta per ser esborrades
-- Afegir candidatures i modificar data d'alta per ser esborrades
-- Afegir logs i modificar data d'alta per ser esborrats
v_resultat := F_CREAR_OFERTA(f_trobar_usr('contacteProva2@correu.com'),'CIFE3',1,'OFERTA A ESBORRAR','REQUERIMENTS MINIMS', 
                            'REQUERIMENTS DESITJATS',10,15000,20000,1,1,1,1,'ESBORRAR',to_date('28/12/2013','DD/MM/YYYY'));  
v_resultat := F_CREAR_OFERTA(f_trobar_usr('contacteProva2@correu.com'),'CIFE3',1,'OFERTA A ESBORRAR','REQUERIMENTS MINIMS', 
                            'REQUERIMENTS DESITJATS',10,15000,20000,1,1,1,1,'ESBORRAR',to_date('28/12/2013','DD/MM/YYYY')); 
v_resultat := F_CREAR_OFERTA(f_trobar_usr('contacteProva2@correu.com'),'CIFE3',1,'OFERTA A ESBORRAR','REQUERIMENTS MINIMS', 
                            'REQUERIMENTS DESITJATS',10,15000,20000,1,1,1,1,'ESBORRAR',to_date('28/12/2013','DD/MM/YYYY')); 
v_resultat := F_CREAR_OFERTA(f_trobar_usr('contacteProva2@correu.com'),'CIFE3',1,'OFERTA A ESBORRAR','REQUERIMENTS MINIMS', 
                            'REQUERIMENTS DESITJATS',10,15000,20000,1,1,1,1,'ESBORRAR',to_date('28/12/2013','DD/MM/YYYY')); 
v_resultat := F_CREAR_OFERTA(f_trobar_usr('contacteProva2@correu.com'),'CIFE3',1,'OFERTA A ESBORRAR','REQUERIMENTS MINIMS', 
                            'REQUERIMENTS DESITJATS',10,15000,20000,1,1,1,1,'ESBORRAR',to_date('28/12/2013','DD/MM/YYYY')); 
v_resultat := F_CREAR_OFERTA(f_trobar_usr('contacteProva2@correu.com'),'CIFE3',1,'OFERTA A ESBORRAR','REQUERIMENTS MINIMS', 
                            'REQUERIMENTS DESITJATS',10,15000,20000,1,1,1,1,'ESBORRAR',to_date('28/12/2013','DD/MM/YYYY')); 
                            
UPDATE OFERTA SET DATA_ALTA = TO_DATE('01/01/2010', 'DD/MM/YYYY')
WHERE descripcio_curta_oferta='ESBORRAR';
--Busco els identificadors de les ofertes a esborrar
select min(id_oferta) into v_oferta 
from oferta
where descripcio_curta_oferta='ESBORRAR';
v_resultat := F_INSCRIURE_CANDIDATURA(v_oferta,f_trobar_usr('candidatProves2@correu.com'),2,f_trobar_id_empresa('CIFE3'),
                        'ESBORRAR');                             
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'candidatura candidat 2 afegida a oferta d''empresa 3');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir candidatura candidat 2 a oferta d''empresa 3');
end if;
v_resultat := F_INSCRIURE_CANDIDATURA(v_oferta+1,f_trobar_usr('candidatProves2@correu.com'),2,f_trobar_id_empresa('CIFE3'),
                        'ESBORRAR');                             
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'candidatura candidat 2 afegida a oferta d''empresa 3');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir candidatura candidat 2 a oferta d''empresa 3');
end if;
v_resultat := F_INSCRIURE_CANDIDATURA(v_oferta+2,f_trobar_usr('candidatProves2@correu.com'),2,f_trobar_id_empresa('CIFE3'),
                        'ESBORRAR');   
if (v_resultat = 1) then insert into t_joc_proves (id,descripcio) values (seq_joc_proves.nextval,'candidatura candidat 2 afegida a oferta d''empresa 3');
else insert into t_joc_proves (id,descripcio) values(seq_joc_proves.nextval,'problemes al afegir candidatura candidat 2 a oferta d''empresa 3');
end if;
UPDATE candidatura SET DATA_ALTA = TO_DATE('01/01/2010', 'DD/MM/YYYY')
WHERE carta_candidatura='ESBORRAR';
-- ADVERTENCIA: Aqui el trigger ens dira que hi ha problemes per que s'esta inserint a la taula de logs.
--              En aquest cas es indicatiu que tot va be, es justament el que estem fem per poder esborrar 
--              després.
insertar_log('missatge a esborrar');
insertar_log('missatge a esborrar');
insertar_log('missatge a esborrar');
insertar_log('missatge a esborrar');
insertar_log('missatge a esborrar');
insertar_log('missatge a esborrar');
insertar_log('missatge a esborrar');
insertar_log('missatge a esborrar');
UPDATE taula_LOG SET DATA_ALTA = TO_DATE('01/01/2010', 'DD/MM/YYYY')
WHERE descripcio_problema='missatge a esborrar';

-- Executem el proces de neteja
executa_neteja;

END PROC_JOC_PROVES;

/


