/*==============================================================*/
/* DBMS name:      ORACLE Version 11g                           */
/* Created on:     11/05/2012 16:52:07                          */
/*==============================================================*/


alter table ADMINISTRADOR
   drop constraint FK_ADMINIST_REFERENCE_USUARI;

alter table CANDIDAT
   drop constraint FK_CANDIDAT_REFERENCE_USUARI;

alter table CANDIDAT
   drop constraint FK_CANDIDAT_REF_M_BUSCANT;

alter table CANDIDATURA
   drop constraint FK_CANDIDAT_REFERENCE_OFERTA;

alter table CANDIDATURA
   drop constraint FK_CANDIDAT_REFERENCE_CURRICUL;

alter table CANDIDATURA
   drop constraint FK_CANDIDAT_REFERENCE_M_ESTAT_;

alter table CIUTAT
   drop constraint FK_CIUTAT_REFERENCE_PROVINCI;

alter table CONTACTE
   drop constraint FK_CONTACTE_REFERENCE_USUARI;

alter table CURRICULUM
   drop constraint FK_CURRICUL_REFERENCE_CANDIDAT;

alter table CV_EXPERIENCIA
   drop constraint FK_CV_EXPER_REFERENCE_SUB_SECT;

alter table CV_EXPERIENCIA
   drop constraint FK_CV_EXPER_REFERENCE_CURRICUL;

alter table CV_EXPERIENCIA
   drop constraint FK_CV_EXPER_REFERENCE_MESTRE_R;

alter table CV_FORMACIO
   drop constraint FK_CV_FORMA_REFERENCE_CURRICUL;

alter table CV_FORMACIO
   drop constraint FK_CV_FORMA_REFERENCE_TIPUS_FO;

alter table CV_IDIOMA
   drop constraint FK_CV_IDIOM_REFERENCE_NIVELL_I;

alter table CV_IDIOMA
   drop constraint FK_CV_IDIOM_REFERENCE_M_IDIOMA;

alter table CV_IDIOMA
   drop constraint FK_CV_IDIOM_REFERENCE_CURRICUL;

alter table CV_IDIOMA
   drop constraint FK_CV_IDIOM_REF_CV_ID_NIVELL_I;

alter table CV_IDIOMA
   drop constraint FK_CV_IDIOM_REF_CV_I__NIVELL_I;

alter table EMPRESA
   drop constraint FK_EMPRESA_REFERENCE_SUB_SECT;

alter table OFERTA
   drop constraint FK_OFERTA_REFERENCE_MESTRE_R;

alter table OFERTA
   drop constraint FK_OFERTA_REFERENCE_ESTAT_OF;

alter table OFERTA
   drop constraint FK_OFERTA_REFERENCE_EMPRESA;

alter table OFERTA
   drop constraint FK_OFERTA_REFERENCE_CIUTAT;

alter table OFERTA
   drop constraint FK_OFERTA_REF_OEFRT_M_TIPUS_;

alter table OFERTA
   drop constraint FK_OFERTA_REF_OFERT_M_TIPUS_;

alter table PROVINCIA
   drop constraint FK_PROVINCI_REFERENCE_PAIS;

alter table REL_CONTACTE_EMPRESA
   drop constraint FK_REL_CONT_REFERENCE_EMPRESA;

alter table REL_CONTACTE_EMPRESA
   drop constraint FK_REL_CONT_REFERENCE_CONTACTE;

alter table SUB_SECTOR
   drop constraint FK_SUB_SECT_REFERENCE_SECTOR;

alter table USUARI
   drop constraint FK_USUARI_REFERENCE_M_ACTIU;

alter table USUARI
   drop constraint FK_USUARI_REF_TIPUS_TIPUS_US;

drop table ADMINISTRADOR cascade constraints;

drop table CANDIDAT cascade constraints;

drop table CANDIDATURA cascade constraints;

drop table CIUTAT cascade constraints;

drop table CONTACTE cascade constraints;

drop table CURRICULUM cascade constraints;

drop table CV_EXPERIENCIA cascade constraints;

drop table CV_FORMACIO cascade constraints;

drop table CV_IDIOMA cascade constraints;

drop table EMPRESA cascade constraints;

drop table ESTAT_OFERTA cascade constraints;

drop table MESTRE_ROLS cascade constraints;

drop table M_ACTIU cascade constraints;

drop table M_BUSCANT cascade constraints;

drop table M_ESTAT_CANDIDATURA cascade constraints;

drop table M_IDIOMA cascade constraints;

drop table M_TIPUS_CONTRACTE cascade constraints;

drop table M_TIPUS_JORNADA cascade constraints;

drop table NIVELL_IDIOMA cascade constraints;

drop table OFERTA cascade constraints;

drop table PAIS cascade constraints;

drop table PARAMETRES_HISTORIC cascade constraints;

drop table PROVINCIA cascade constraints;

drop table REL_CONTACTE_EMPRESA cascade constraints;

drop table SECTOR cascade constraints;

drop table SUB_SECTOR cascade constraints;

drop table TAULA_LOG cascade constraints;

drop table TIPUS_FORMACIONS cascade constraints;

drop table TIPUS_USUARI cascade constraints;

drop table T_JOC_PROVES cascade constraints;

drop table USUARI cascade constraints;

drop sequence SEQ_CV;

drop sequence SEQ_EMPRESA;

drop sequence SEQ_EXPERIENCIA;

drop sequence SEQ_FORMACIO;

drop sequence SEQ_JOC_PROVES;

drop sequence SEQ_LOG;

drop sequence SEQ_OFERTES;

drop sequence SEQ_USUARI;

create sequence SEQ_CV
increment by 1
start with 1
 nomaxvalue;

create sequence SEQ_EMPRESA
increment by 1
start with 1
 nomaxvalue;

create sequence SEQ_EXPERIENCIA
increment by 1
start with 1
 nomaxvalue;

create sequence SEQ_FORMACIO
increment by 1
start with 1
 nomaxvalue;

create sequence SEQ_JOC_PROVES
increment by 1
start with 1
 nomaxvalue;

create sequence SEQ_LOG
increment by 1
start with 1
 nomaxvalue;

create sequence SEQ_OFERTES
increment by 1
start with 1
 nomaxvalue;

create sequence SEQ_USUARI
increment by 1
start with 5
 nomaxvalue;

/*==============================================================*/
/* Table: ADMINISTRADOR                                         */
/*==============================================================*/
create table ADMINISTRADOR 
(
   ID_USUARI            NUMBER               not null,
   CODI_MATRICULA       NUMBER               not null,
   TELEFON              CHAR(13 CHAR),
   constraint PK_ADMINISTRADOR primary key (ID_USUARI),
   constraint AK_AK_CODI_MATRICULA_ADMINIST unique (CODI_MATRICULA)
);

/*==============================================================*/
/* Table: CANDIDAT                                              */
/*==============================================================*/
create table CANDIDAT 
(
   ID_USUARI            NUMBER               not null,
   NOM                  VARCHAR2(50 CHAR)    not null,
   COGNOM1              VARCHAR2(50)         not null,
   COGNOM2              VARCHAR2(50 CHAR),
   ESTA_BUSCANT         NUMBER               not null,
   constraint PK_CANDIDAT primary key (ID_USUARI)
);

/*==============================================================*/
/* Table: CANDIDATURA                                           */
/*==============================================================*/
create table CANDIDATURA 
(
   ID_OFERTA_CANDIDATURA NUMBER               not null,
   ID_CANDIDAT_CV       NUMBER               not null,
   ID_CV_CANDIDATURA    NUMBER               not null,
   ID_EMPRESA_OFERTA    NUMBER               not null,
   DATA_ALTA            DATE                 not null,
   ESTAT_CANDIDATURA    NUMBER               not null,
   CARTA_CANDIDATURA    VARCHAR2(500 CHAR),
   DATA_ACCEPTACIO      DATE,
   constraint PK_CANDIDATURA primary key (ID_OFERTA_CANDIDATURA, ID_CANDIDAT_CV, ID_CV_CANDIDATURA, ID_EMPRESA_OFERTA)
);

/*==============================================================*/
/* Table: CIUTAT                                                */
/*==============================================================*/
create table CIUTAT 
(
   ID_PROVINCIA_CIUTAT  NUMBER               not null,
   ID_CIUTAT            NUMBER               not null,
   ID_PAIS_PROVINCIA    NUMBER,
   DESC_CIUTAT          VARCHAR2(50 CHAR)    not null,
   constraint PK_CIUTAT primary key (ID_PROVINCIA_CIUTAT, ID_CIUTAT)
);

/*==============================================================*/
/* Table: CONTACTE                                              */
/*==============================================================*/
create table CONTACTE 
(
   ID_USUARI            NUMBER               not null,
   NIF                  VARCHAR2(9 CHAR)     not null,
   PRIORITAT            NUMBER               not null,
   TELF1                VARCHAR2(12 CHAR)    not null,
   TELF2                VARCHAR2(12 CHAR),
   CORREU2              VARCHAR2(50 CHAR),
   NOM                  VARCHAR2(50 CHAR)    not null,
   COGNOM1              VARCHAR2(50 CHAR)    not null,
   COGNOM2              VARCHAR2(50 CHAR),
   CARREC               VARCHAR2(50 CHAR),
   constraint PK_CONTACTE primary key (ID_USUARI),
   constraint AK_AK_NIF_CONTACTE_CONTACTE unique (NIF)
);

/*==============================================================*/
/* Table: CURRICULUM                                            */
/*==============================================================*/
create table CURRICULUM 
(
   ID_CANDIDAT_CV       NUMBER               not null,
   ID_CV                NUMBER               not null,
   DATA_ALTA_CV         DATE                 not null,
   DATA_BAIXA_CV        DATE,
   DESCRIPCIO_CV        VARCHAR2(50 CHAR)    not null,
   constraint PK_CURRICULUM primary key (ID_CANDIDAT_CV, ID_CV)
);

/*==============================================================*/
/* Table: CV_EXPERIENCIA                                        */
/*==============================================================*/
create table CV_EXPERIENCIA 
(
   ID_CANDIDAT_CV       NUMBER               not null,
   ID_CV                NUMBER               not null,
   ID_EXPERIENCIA       NUMBER               not null,
   CV_ID_SECTOR         NUMBER,
   CV_SUB_SECTOR        NUMBER               not null,
   DATA_INICI_EXP       DATE                 not null,
   DATA_FI_EXP          DATE,
   ROL_EXP              NUMBER               not null,
   PERSONES_CARREC      NUMBER,
   DESCRIPCIO_EXP       VARCHAR2(200 CHAR)   not null,
   constraint PK_CV_EXPERIENCIA primary key (ID_CANDIDAT_CV, ID_CV, ID_EXPERIENCIA, DATA_INICI_EXP)
);

/*==============================================================*/
/* Table: CV_FORMACIO                                           */
/*==============================================================*/
create table CV_FORMACIO 
(
   ID_CANDIDAT_CV       NUMBER               not null,
   ID_CV                NUMBER               not null,
   ID_FORMACIO          NUMBER               not null,
   TIPUS_FORMACIO       NUMBER               not null,
   DATA_INICI_FORMACIO  DATE                 not null,
   DATA_FI_FORMACIO     DATE,
   DESCRIPCIO_FORMACIO  VARCHAR2(50 CHAR)    not null,
   CERTIFICADA          NUMBER               not null,
   constraint PK_CV_FORMACIO primary key (ID_CANDIDAT_CV, ID_CV, ID_FORMACIO)
);

/*==============================================================*/
/* Table: CV_IDIOMA                                             */
/*==============================================================*/
create table CV_IDIOMA 
(
   ID_CANDIDAT_CV       NUMBER               not null,
   ID_CV                NUMBER               not null,
   ID_IDIOMA            NUMBER               not null,
   NIVELL_PARLAT        NUMBER               not null,
   NIVELL_LLEGIT        NUMBER               not null,
   NIVELL_ESCRIT        NUMBER,
   constraint PK_CV_IDIOMA primary key (ID_CANDIDAT_CV, ID_CV, ID_IDIOMA)
);

/*==============================================================*/
/* Table: EMPRESA                                               */
/*==============================================================*/
create table EMPRESA 
(
   ID_EMPRESA           NUMBER               not null,
   NOM_EMPRESA          VARCHAR(50),
   CIF_EMPRESA          VARCHAR2(9 CHAR)     not null,
   DATA_ALTA            DATE                 not null,
   DATA_BAIXA           DATE,
   NOMBRE_TREBALLADORS  NUMBER               not null,
   DESCRIPCIO_EMPRESA   VARCHAR2(500 CHAR)   not null,
   SUB_SECTOR_EMPRESA   NUMBER               not null,
   ADRECA_WEB_EMPRESA   VARCHAR2(200 CHAR),
   SECTOR_EMPRESA       NUMBER,
   constraint PK_EMPRESA primary key (ID_EMPRESA),
   constraint AK_AK_CORREU_ELECTRON_EMPRESA unique (CIF_EMPRESA)
);

/*==============================================================*/
/* Table: ESTAT_OFERTA                                          */
/*==============================================================*/
create table ESTAT_OFERTA 
(
   ID_ESTAT_OFERTA      NUMBER               not null,
   DESC_ESTAT_OFERTA    VARCHAR2(50 CHAR)    not null,
   constraint PK_ESTAT_OFERTA primary key (ID_ESTAT_OFERTA)
);

/*==============================================================*/
/* Table: MESTRE_ROLS                                           */
/*==============================================================*/
create table MESTRE_ROLS 
(
   ID_ROL               NUMBER               not null,
   DESC_ROL             VARCHAR2(50 CHAR)    not null,
   constraint PK_MESTRE_ROLS primary key (ID_ROL)
);

/*==============================================================*/
/* Table: M_ACTIU                                               */
/*==============================================================*/
create table M_ACTIU 
(
   M_ACTIU              NUMBER               not null,
   DESCRIPCIO_ACTIU     VARCHAR2(50)         not null,
   constraint PK_M_ACTIU primary key (M_ACTIU)
);

/*==============================================================*/
/* Table: M_BUSCANT                                             */
/*==============================================================*/
create table M_BUSCANT 
(
   M_ESTA_BUSCANT       NUMBER               not null,
   DESCRIPCIO_BUSCANT   VARCHAR2(50)         not null,
   constraint PK_M_BUSCANT primary key (M_ESTA_BUSCANT)
);

/*==============================================================*/
/* Table: M_ESTAT_CANDIDATURA                                   */
/*==============================================================*/
create table M_ESTAT_CANDIDATURA 
(
   M_ESTAT_CANDIDATURA  NUMBER               not null,
   DESCRIPCIO_ESTAT_CANDIDATURA VARCHAR2(50)         not null,
   constraint PK_M_ESTAT_CANDIDATURA primary key (M_ESTAT_CANDIDATURA)
);

/*==============================================================*/
/* Table: M_IDIOMA                                              */
/*==============================================================*/
create table M_IDIOMA 
(
   ID_IDIOMA            NUMBER               not null,
   DESC_IDIOMA          VARCHAR2(50 CHAR)    not null,
   constraint PK_M_IDIOMA primary key (ID_IDIOMA)
);

/*==============================================================*/
/* Table: M_TIPUS_CONTRACTE                                     */
/*==============================================================*/
create table M_TIPUS_CONTRACTE 
(
   M_CONTRACTE          NUMBER               not null,
   DESCRIPCIO_CONTRACTE VARCHAR2(50)         not null,
   constraint PK_M_TIPUS_CONTRACTE primary key (M_CONTRACTE)
);

/*==============================================================*/
/* Table: M_TIPUS_JORNADA                                       */
/*==============================================================*/
create table M_TIPUS_JORNADA 
(
   M_JORNADA            NUMBER               not null,
   DESCRIPCIO_JORNADA   VARCHAR2(50)         not null,
   constraint PK_M_TIPUS_JORNADA primary key (M_JORNADA)
);

/*==============================================================*/
/* Table: NIVELL_IDIOMA                                         */
/*==============================================================*/
create table NIVELL_IDIOMA 
(
   ID_NIVELL            NUMBER               not null,
   DESC_NIVELL          VARCHAR2(50 CHAR)    not null,
   constraint PK_NIVELL_IDIOMA primary key (ID_NIVELL)
);

/*==============================================================*/
/* Table: OFERTA                                                */
/*==============================================================*/
create table OFERTA 
(
   ID_EMPRESA_OFERTA    NUMBER               not null,
   ID_OFERTA            NUMBER               not null,
   ID_PROVINCIA_CIUTAT  NUMBER               not null,
   DATA_ALTA            DATE                 not null,
   DESCRIPCIO_OFERTA    VARCHAR2(500 CHAR)   not null,
   REQUERIEMENTS_MINIMS_OFERTA VARCHAR2(500 CHAR),
   REQUERIMENTS_DESITJATS_OFERTA VARCHAR2(500 CHAR),
   NOMBRE_VACANTS_OFERTA NUMBER               not null,
   SALARI_MINIM_OFERTA  VARCHAR2(200 CHAR),
   SALARI_MAXIM_OFERTA  NUMBER,
   TIPUS_CONTRACTE_OFERTA NUMBER               not null,
   TIPUS_JORNADA_OFERTA NUMBER               not null,
   CIUTAT_TREBALL_OFERTA NUMBER               not null,
   ROL_CANDIDAT_OFERTA  NUMBER               not null,
   DESCRIPCIO_CURTA_OFERTA VARCHAR2(15 CHAR)    not null,
   DATA_LIMIT           DATE,
   ESTAT_OFERTA         NUMBER               not null,
   constraint PK_OFERTA primary key (ID_EMPRESA_OFERTA, ID_OFERTA)
);

/*==============================================================*/
/* Table: PAIS                                                  */
/*==============================================================*/
create table PAIS 
(
   ID_PAIS              NUMBER               not null,
   DESC_PAIS            VARCHAR2(50 CHAR)    not null,
   constraint PK_PAIS primary key (ID_PAIS)
);

/*==============================================================*/
/* Table: PARAMETRES_HISTORIC                                   */
/*==============================================================*/
create table PARAMETRES_HISTORIC 
(
   NOM_TAULA            VARCHAR2(100 CHAR)   not null,
   TEMPS                NUMBER,
   constraint PK_PARAMETRES_HISTORIC primary key (NOM_TAULA)
);

/*==============================================================*/
/* Table: PROVINCIA                                             */
/*==============================================================*/
create table PROVINCIA 
(
   ID_PAIS_PROVINCIA    NUMBER               not null,
   ID_PROVINCIA         NUMBER               not null,
   DESC_PROVINCIA       VARCHAR2(50 CHAR)    not null,
   constraint PK_PROVINCIA primary key (ID_PAIS_PROVINCIA, ID_PROVINCIA)
);

/*==============================================================*/
/* Table: REL_CONTACTE_EMPRESA                                  */
/*==============================================================*/
create table REL_CONTACTE_EMPRESA 
(
   CONTACTE_REL         NUMBER               not null,
   EMPRESA_REL          NUMBER               not null,
   constraint PK_REL_CONTACTE_EMPRESA primary key (CONTACTE_REL, EMPRESA_REL)
);

/*==============================================================*/
/* Table: SECTOR                                                */
/*==============================================================*/
create table SECTOR 
(
   ID_SECTOR            NUMBER               not null,
   DESC_SECTOR          VARCHAR2(50 CHAR)    not null,
   constraint PK_SECTOR primary key (ID_SECTOR)
);

/*==============================================================*/
/* Table: SUB_SECTOR                                            */
/*==============================================================*/
create table SUB_SECTOR 
(
   ID_SECTOR            NUMBER               not null,
   ID_SUB_SECTOR        NUMBER               not null,
   DESC_SUB_SECTOR      VARCHAR2(50 CHAR)    not null,
   constraint PK_SUB_SECTOR primary key (ID_SECTOR, ID_SUB_SECTOR)
);

/*==============================================================*/
/* Table: TAULA_LOG                                             */
/*==============================================================*/
create table TAULA_LOG 
(
   ID_LOG               NUMBER               not null,
   DATA_ALTA            DATE,
   DESCRIPCIO_PROBLEMA  VARCHAR2(500 CHAR),
   constraint PK_TAULA_LOG primary key (ID_LOG)
);

/*==============================================================*/
/* Table: TIPUS_FORMACIONS                                      */
/*==============================================================*/
create table TIPUS_FORMACIONS 
(
   ID_TIPUS_FORMACIO    NUMBER               not null,
   DESC_TIPUS_FORMACIO  VARCHAR2(100 CHAR),
   constraint PK_TIPUS_FORMACIONS primary key (ID_TIPUS_FORMACIO)
);

/*==============================================================*/
/* Table: TIPUS_USUARI                                          */
/*==============================================================*/
create table TIPUS_USUARI 
(
   TIPUS_USUARI         NUMBER               not null,
   DESCRIPCIO_TIPUS_USUARI VARCHAR2(200 CHAR)   not null,
   constraint PK_TIPUS_USUARI primary key (TIPUS_USUARI)
);

/*==============================================================*/
/* Table: T_JOC_PROVES                                          */
/*==============================================================*/
create table T_JOC_PROVES 
(
   ID                   NUMBER               not null,
   DESCRIPCIO           VARCHAR2(200 CHAR)   not null,
   constraint PK_T_JOC_PROVES primary key (ID)
);

/*==============================================================*/
/* Table: USUARI                                                */
/*==============================================================*/
create table USUARI 
(
   ID_USUARI            NUMBER               not null,
   CORREU_USUARI        VARCHAR2(50)         not null,
   PASSWORD_USUARI      VARCHAR2(50)         not null,
   DATA_ALTA            DATE                 not null,
   DATA_ULTIM_ACCES     DATE                 not null,
   ACTIU                NUMBER               not null,
   TIPUS_USUARI         NUMBER               not null,
   constraint PK_USUARI primary key (ID_USUARI),
   constraint AK_AK_CORREU_ELECTRON_USUARI unique (CORREU_USUARI)
);

alter table ADMINISTRADOR
   add constraint FK_ADMINIST_REFERENCE_USUARI foreign key (ID_USUARI)
      references USUARI (ID_USUARI);

alter table CANDIDAT
   add constraint FK_CANDIDAT_REFERENCE_USUARI foreign key (ID_USUARI)
      references USUARI (ID_USUARI);

alter table CANDIDAT
   add constraint FK_CANDIDAT_REF_M_BUSCANT foreign key (ESTA_BUSCANT)
      references M_BUSCANT (M_ESTA_BUSCANT);

alter table CANDIDATURA
   add constraint FK_CANDIDAT_REFERENCE_OFERTA foreign key (ID_EMPRESA_OFERTA, ID_OFERTA_CANDIDATURA)
      references OFERTA (ID_EMPRESA_OFERTA, ID_OFERTA)
      on delete cascade;

alter table CANDIDATURA
   add constraint FK_CANDIDAT_REFERENCE_CURRICUL foreign key (ID_CANDIDAT_CV, ID_CV_CANDIDATURA)
      references CURRICULUM (ID_CANDIDAT_CV, ID_CV);

alter table CANDIDATURA
   add constraint FK_CANDIDAT_REFERENCE_M_ESTAT_ foreign key (ESTAT_CANDIDATURA)
      references M_ESTAT_CANDIDATURA (M_ESTAT_CANDIDATURA);

alter table CIUTAT
   add constraint FK_CIUTAT_REFERENCE_PROVINCI foreign key (ID_PAIS_PROVINCIA, ID_PROVINCIA_CIUTAT)
      references PROVINCIA (ID_PAIS_PROVINCIA, ID_PROVINCIA);

alter table CONTACTE
   add constraint FK_CONTACTE_REFERENCE_USUARI foreign key (ID_USUARI)
      references USUARI (ID_USUARI);

alter table CURRICULUM
   add constraint FK_CURRICUL_REFERENCE_CANDIDAT foreign key (ID_CANDIDAT_CV)
      references CANDIDAT (ID_USUARI);

alter table CV_EXPERIENCIA
   add constraint FK_CV_EXPER_REFERENCE_SUB_SECT foreign key (CV_ID_SECTOR, CV_SUB_SECTOR)
      references SUB_SECTOR (ID_SECTOR, ID_SUB_SECTOR);

alter table CV_EXPERIENCIA
   add constraint FK_CV_EXPER_REFERENCE_CURRICUL foreign key (ID_CANDIDAT_CV, ID_CV)
      references CURRICULUM (ID_CANDIDAT_CV, ID_CV);

alter table CV_EXPERIENCIA
   add constraint FK_CV_EXPER_REFERENCE_MESTRE_R foreign key (ROL_EXP)
      references MESTRE_ROLS (ID_ROL);

alter table CV_FORMACIO
   add constraint FK_CV_FORMA_REFERENCE_CURRICUL foreign key (ID_CANDIDAT_CV, ID_CV)
      references CURRICULUM (ID_CANDIDAT_CV, ID_CV);

alter table CV_FORMACIO
   add constraint FK_CV_FORMA_REFERENCE_TIPUS_FO foreign key (TIPUS_FORMACIO)
      references TIPUS_FORMACIONS (ID_TIPUS_FORMACIO);

alter table CV_IDIOMA
   add constraint FK_CV_IDIOM_REFERENCE_NIVELL_I foreign key (NIVELL_LLEGIT)
      references NIVELL_IDIOMA (ID_NIVELL);

alter table CV_IDIOMA
   add constraint FK_CV_IDIOM_REFERENCE_M_IDIOMA foreign key (ID_IDIOMA)
      references M_IDIOMA (ID_IDIOMA);

alter table CV_IDIOMA
   add constraint FK_CV_IDIOM_REFERENCE_CURRICUL foreign key (ID_CANDIDAT_CV, ID_CV)
      references CURRICULUM (ID_CANDIDAT_CV, ID_CV);

alter table CV_IDIOMA
   add constraint FK_CV_IDIOM_REF_CV_ID_NIVELL_I foreign key (NIVELL_PARLAT)
      references NIVELL_IDIOMA (ID_NIVELL);

alter table CV_IDIOMA
   add constraint FK_CV_IDIOM_REF_CV_I__NIVELL_I foreign key (NIVELL_ESCRIT)
      references NIVELL_IDIOMA (ID_NIVELL);

alter table EMPRESA
   add constraint FK_EMPRESA_REFERENCE_SUB_SECT foreign key (SECTOR_EMPRESA, SUB_SECTOR_EMPRESA)
      references SUB_SECTOR (ID_SECTOR, ID_SUB_SECTOR);

alter table OFERTA
   add constraint FK_OFERTA_REFERENCE_MESTRE_R foreign key (ROL_CANDIDAT_OFERTA)
      references MESTRE_ROLS (ID_ROL);

alter table OFERTA
   add constraint FK_OFERTA_REFERENCE_ESTAT_OF foreign key (ESTAT_OFERTA)
      references ESTAT_OFERTA (ID_ESTAT_OFERTA);

alter table OFERTA
   add constraint FK_OFERTA_REFERENCE_EMPRESA foreign key (ID_EMPRESA_OFERTA)
      references EMPRESA (ID_EMPRESA);

alter table OFERTA
   add constraint FK_OFERTA_REFERENCE_CIUTAT foreign key (ID_PROVINCIA_CIUTAT, CIUTAT_TREBALL_OFERTA)
      references CIUTAT (ID_PROVINCIA_CIUTAT, ID_CIUTAT);

alter table OFERTA
   add constraint FK_OFERTA_REF_OEFRT_M_TIPUS_ foreign key (TIPUS_JORNADA_OFERTA)
      references M_TIPUS_JORNADA (M_JORNADA);

alter table OFERTA
   add constraint FK_OFERTA_REF_OFERT_M_TIPUS_ foreign key (TIPUS_CONTRACTE_OFERTA)
      references M_TIPUS_CONTRACTE (M_CONTRACTE);

alter table PROVINCIA
   add constraint FK_PROVINCI_REFERENCE_PAIS foreign key (ID_PAIS_PROVINCIA)
      references PAIS (ID_PAIS);

alter table REL_CONTACTE_EMPRESA
   add constraint FK_REL_CONT_REFERENCE_EMPRESA foreign key (EMPRESA_REL)
      references EMPRESA (ID_EMPRESA);

alter table REL_CONTACTE_EMPRESA
   add constraint FK_REL_CONT_REFERENCE_CONTACTE foreign key (CONTACTE_REL)
      references CONTACTE (ID_USUARI);

alter table SUB_SECTOR
   add constraint FK_SUB_SECT_REFERENCE_SECTOR foreign key (ID_SECTOR)
      references SECTOR (ID_SECTOR);

alter table USUARI
   add constraint FK_USUARI_REFERENCE_M_ACTIU foreign key (ACTIU)
      references M_ACTIU (M_ACTIU);

alter table USUARI
   add constraint FK_USUARI_REF_TIPUS_TIPUS_US foreign key (TIPUS_USUARI)
      references TIPUS_USUARI (TIPUS_USUARI);

